
spool c:\BSPb\Parus8\Addon\logs\__create_objects_UdoSalaryRegistersTransfers.log

create or replace package PKG_UDOT_SLREGTRN
as
  --    ()
  procedure BASE_FORM
  (
    nCOMPANY                  in number,
    nRN                       in number,       -- 
    nIDENT                    in number,       -- 
    dFORM_DATE                in date,         --  
    nAGENT                    in number,       --  
    nAGNJURDOCS               in number,       -- 
    sAGNBANKS                 in varchar2,     --  
    sREGCRN                   in varchar2,     --   
    sDOCTYPES                 in varchar2,     --  
    sDOC_PREF                 in varchar2,     --   
    dDOC_DATE                 in date,         --  
    nGRPTRTYPE                in number,       --    
    nGRPBANKPRG               in number,       --     
    nRESULT                  out number
  );
/*
  --   
  procedure BASE_FILL_BUFF
  (
    nCOMPANY                  in number,       -- 
    nIDENT                    in number,       --  
    dDOC_DATE                 in date,         --   
    nDATE_SIGN                in number,       --  -   -
    sMODEL_DOC                in varchar2,     --   
    nCRN_DOC                  in varchar2,     -- ,   
    nRESULT                  out number
  );
*/
  --       (   P_BANKDOCSBUFF_BASE_REPLACE)
  procedure BDOC_APPLY
  (
    nCOMPANY                  in number,       -- 
    nUDOT_SLREGTRNPR          in number,       --     
    nBANKDOCS                 in number        --    
  );
end PKG_UDOT_SLREGTRN;
/

grant execute on PKG_UDOT_SLREGTRN to public;

create or replace procedure P_UDOT_SLREGTRN_JOINS
(
  nCOMPANY                  in number,       --   
  nAGENT                    in number,       --  
  sJUR_PERS                 in varchar2,     --  ()
  sDOCTYPES                 in varchar2,     --   ()
  sAGNBANKS                 in varchar2,     --  () ()
  sBANKPRG                  in varchar2,     --   ()
  sAGNACC                   in varchar2,     --  /   ( )
  sSLTRTYPE                 in varchar2,     --   ()
  nJUR_PERS                 out number,      -- 
  nDOC_TYPE                 out number,      --   (  DOCTYPES(RN))
  nAGNBANKS                 out number,      --  ()
  nBANKPRG                  out number,      --  
  nAGNACC                   out number,      --  /  
  nSLTRTYPE                 out number       --  
)
as
begin
  -- 
  FIND_JURPERSONS_CODE( 0,0,nCOMPANY,sJUR_PERS,nJUR_PERS );

  --  
  FIND_DOCTYPES_CODE_EX( 0,0,nCOMPANY,sDOCTYPES,nDOC_TYPE );

  --  ()
  FIND_AGNBANKS_AGENT( 0, nCOMPANY, sAGNBANKS, nAGNBANKS );

  --  
  FIND_BANKPRG_CODE( 0, 1, nCOMPANY, sBANKPRG, nBANKPRG );

  --  /  
  FIND_AGNACC_CODE_EX( 0, 1, nCOMPANY, nAGENT, null, sAGNACC, nAGNACC );

  --  
  FIND_SLTRTYPE_CODE( 0,1,nCOMPANY,sSLTRTYPE,nSLTRTYPE );
end P_UDOT_SLREGTRN_JOINS;
/

grant execute on P_UDOT_SLREGTRN_JOINS to public;

create or replace procedure UDOT_P_SLTRANSFERS_REG_CREATE
(
  nCOMPANY                  in number,     -- .
  nIDENT                    in number,     --     selectlist (not null)
  sJUR_PERS                 in varchar2,   --  
  sAGENT                    in varchar2,   --  
  sAGNBANS                  in varchar2,   --  
  sREGCRN                   in varchar2,   --   
  sDOCTYPES                 in varchar2,   --  
  sDOC_PREF                 in varchar2,   --   
  dDOC_DATE                 in date,       --  
  dFORM_DATE                in date,       --  
  nGRPTRTYPE                in number,     --    
  nGRPBANKPRG               in number default 0,     --     
  nRES                     out number      --   (0 -   , >= 1 -  )
)
as
  nJUR_PERS                 PKG_STD.tREF;  --  
  nAGENT                    PKG_STD.tREF;  -- 
  sSQL                      PKG_STD.tSQL;
begin
  --   
  find_agnlist_by_mnemo( 0, nCOMPANY, sAGENT, nAGENT);

  if sJUR_PERS is not null then
    FIND_JURPERSONS_CODE( 0,0,nCOMPANY,sJUR_PERS,nJUR_PERS );
  end if;

  for rec in
  (
    select B.RN,
           B.JURPERSONS,
           J.AGENT,
           case
             when exists (select null
                            from DOCLINKS L
                            where L.IN_DOCUMENT = B.RN
                              and L.IN_UNITCODE = 'SalaryTransfers'
                              and L.OUT_UNITCODE ='BankDocuments')
               then 1
               else 0
           end IS_BD,
           case
             when exists (select null
                            from DOCLINKS L
                            where L.IN_DOCUMENT = B.RN
                              and L.IN_UNITCODE ='SalaryTransfers'
                              and L.OUT_UNITCODE ='UdotSalaryRegistersTransfers')
               then 1
               else 0
           end IS_REG
      from SELECTLIST  A,
           SLTRANSFERS B,
           JURPERSONS  J
     where A.DOCUMENT   = B.RN
       and B.JURPERSONS = J.RN
       and A.IDENT      = nIDENT
  )
  loop
    if /*rec.IS_BD = 1 or */rec.IS_REG = 1 or (nJUR_PERS is not null and rec.JURPERSONS <> nJUR_PERS) then
      delete from SELECTLIST
       where IDENT = nIDENT
         and DOCUMENT = rec.RN;
    else
      nAGENT := rec.AGENT;
    end if;
  end loop;

  /*   */
  sSQL := 'begin
    PKG_UDOT_SLREGTRN.BASE_FORM
    (
      :nCOMPANY,
      null,            -- nRN
      :nIDENT,
      :dFORM_DATE,
      :nAGENT,
      :nAGNJURDOCS,
      :sAGNBANS,
      :sREGCRN,
      :sDOCTYPES,
      :sDOC_PREF,
      :dDOC_DATE,
      :nGRPTRTYPE,
      :nGRPBANKPRG,
      :nRESULT
    );end;';
  execute immediate sSQL using
    nCOMPANY,
    nIDENT,
    dFORM_DATE,
    nAGENT,
--    to_number(sAGNJURDOCS),
    to_number(null),
    sAGNBANS,
    sREGCRN,
    sDOCTYPES,
    sDOC_PREF,
    dDOC_DATE,
    nGRPTRTYPE,
    nGRPBANKPRG,
    out nRES;
end UDOT_P_SLTRANSFERS_REG_CREATE;
/

grant execute on UDOT_P_SLTRANSFERS_REG_CREATE to public;

create or replace procedure UDOT_P_TRIM_PREF_NUMB
(
  sPREF      in out varchar2
 ,sNUMB      in out varchar2
)
as
begin
  sPREF  := trim(sPREF);
  sNUMB  := trim(sNUMB);
end;
/

grant execute on UDOT_P_TRIM_PREF_NUMB to public;

create or replace function udot_get_sysdate return date
as
begin
  return sysdate;
end udot_get_sysdate;
/

grant execute on UDOT_GET_SYSDATE to public;

/*   (  )    */
create table UDOT_SLREGTRN (
DUMMY varchar2(1) default null,
/*   */
RN number(17) not null,
/*    */
COMPANY number(17) not null,
/*    */
CRN number(17) not null,
/*     */
JUR_PERS number(17) not null,
/*        . */
JPERS number(17) default null,
/*     */
DOC_TYPE number(17) not null,
/*   */
DOC_PREF varchar2(80) default null,
/*   */
DOC_NUMB varchar2(80) not null,
/*   */
DOC_DATE date not null,
/*          */
DOC_YEAR number(4) default null,
/*     */
AGNBANKS number(17) not null,
/*    -. */
AGNJURDOCS number(17) default null,
/*      () */
BANKPRG number(17) default null,
/*      . */
AGNACC number(17) default null,
/*     */
SLTRTYPE number(17) default null,
/*    */
FILENAME varchar2(240) default null,
/*    */
FORM_DATE date default null,
/*       (  dbf) */
BDATA blob default null,
constraint C_UDOT_SLREGTRN_PK primary key (RN)  using index tablespace &INDX_B1709,
constraint C_UDOT_SLREGTRN_DOC_TYPE_UK unique (COMPANY,JPERS,DOC_YEAR,DOC_TYPE,DOC_PREF,DOC_NUMB)  using index tablespace &INDX_B1709,
constraint C_UDOT_SLREGTRN_DOC_NUMB_NB check (rtrim(DOC_NUMB) is not null),
constraint C_UDOT_SLREGTRN_DOC_PREF_NB check (DOC_PREF is null or rtrim(DOC_PREF) is not null)
)
LOB (BDATA) store as (tablespace &LOBS_B1709 NOCACHE NOLOGGING);
-- Add comments to the table and to the columns
comment on table UDOT_SLREGTRN
  is '  (  )   ';
comment on column UDOT_SLREGTRN.RN
  is ' ';
comment on column UDOT_SLREGTRN.COMPANY
  is '  ';
comment on column UDOT_SLREGTRN.CRN
  is '  ';
comment on column UDOT_SLREGTRN.JUR_PERS
  is '   ';
comment on column UDOT_SLREGTRN.JPERS
  is '       .';
comment on column UDOT_SLREGTRN.DOC_TYPE
  is '   ';
comment on column UDOT_SLREGTRN.DOC_PREF
  is ' ';
comment on column UDOT_SLREGTRN.DOC_NUMB
  is ' ';
comment on column UDOT_SLREGTRN.DOC_DATE
  is ' ';
comment on column UDOT_SLREGTRN.DOC_YEAR
  is '        ';
comment on column UDOT_SLREGTRN.AGNBANKS
  is '   ';
comment on column UDOT_SLREGTRN.AGNJURDOCS
  is '   -.';
comment on column UDOT_SLREGTRN.BANKPRG
  is '     ()';
comment on column UDOT_SLREGTRN.AGNACC
  is '     .';
comment on column UDOT_SLREGTRN.SLTRTYPE
  is '   ';
comment on column UDOT_SLREGTRN.FILENAME
  is '  ';
comment on column UDOT_SLREGTRN.FORM_DATE
  is '  ';
comment on column UDOT_SLREGTRN.BDATA
  is '      (  dbf)';
-- Create foreign key constraints
alter table UDOT_SLREGTRN add (
constraint C_UDOT_SLREGTRN_CRN_FK foreign key (CRN)
  references ACATALOG (RN),
constraint C_UDOT_SLREGTRN_AGNACC_FK foreign key (AGNACC)
  references AGNACC (RN),
constraint C_UDOT_SLREGTRN_AGNBANKS_FK foreign key (AGNBANKS)
  references AGNBANKS (RN),
constraint C_UDOT_SLREGTRN_AGNJURDOCS_FK foreign key (AGNJURDOCS)
  references AGNJURDOCS (RN),
constraint C_UDOT_SLREGTRN_BANKPRG_FK foreign key (BANKPRG)
  references BANKPRG (RN),
constraint C_UDOT_SLREGTRN_COMPANY_FK foreign key (COMPANY)
  references COMPANIES (RN),
constraint C_UDOT_SLREGTRN_DOC_TYPE_FK foreign key (DOC_TYPE)
  references DOCTYPES (RN),
constraint C_UDOT_SLREGTRN_JUR_PERS_FK foreign key (JUR_PERS)
  references JURPERSONS (RN),
constraint C_UDOT_SLREGTRN_SLTRTYPE_FK foreign key (SLTRTYPE)
  references SLTRTYPE (RN)
);

/*       () */
create table UDOT_SLREGTRNPR (
DUMMY varchar2(1) default null,
/*   */
RN number(17) not null,
/*    */
COMPANY number(17) not null,
/*    */
CRN number(17) not null,
/*    */
PRN number(17) not null,
/*     */
JUR_PERS number(17) not null,
/*    */
AGNLIST number(17) not null,
/*      */
AGNACC number(17) not null,
/*   */
TRN_SUM number(17,2) default 0 not null,
/*      */
KVDRN number(17,0) default null,
/*   */
FZ229_SUM number(17,2) default 0 not null,
constraint C_UDOT_SLREGTRNPR_PK primary key (RN)  using index tablespace &INDX_B1709,
constraint C_UDOT_SLREGTRNPR_AGNLIST_UK unique (PRN,AGNLIST,AGNACC)  using index tablespace &INDX_B1709
);
-- Add comments to the table and to the columns
comment on table UDOT_SLREGTRNPR
  is '      ()';
comment on column UDOT_SLREGTRNPR.RN
  is ' ';
comment on column UDOT_SLREGTRNPR.COMPANY
  is '  ';
comment on column UDOT_SLREGTRNPR.CRN
  is '  ';
comment on column UDOT_SLREGTRNPR.PRN
  is '  ';
comment on column UDOT_SLREGTRNPR.JUR_PERS
  is '   ';
comment on column UDOT_SLREGTRNPR.AGNLIST
  is '  ';
comment on column UDOT_SLREGTRNPR.AGNACC
  is '    ';
comment on column UDOT_SLREGTRNPR.TRN_SUM
  is ' ';
comment on column UDOT_SLREGTRNPR.KVDRN
  is '    ';
comment on column UDOT_SLREGTRNPR.FZ229_SUM
  is ' ';
-- Create foreign key constraints
alter table UDOT_SLREGTRNPR add (
constraint C_UDOT_SLREGTRNPR_CRN_FK foreign key (CRN)
  references ACATALOG (RN),
constraint C_UDOT_SLREGTRNPR_AGNACC_FK foreign key (AGNACC)
  references AGNACC (RN),
constraint C_UDOT_SLREGTRNPR_AGNLIST_FK foreign key (AGNLIST)
  references AGNLIST (RN),
constraint C_UDOT_SLREGTRNPR_COMPANY_FK foreign key (COMPANY)
  references COMPANIES (RN),
constraint C_UDOT_SLREGTRNPR_JURPERS_FK foreign key (JUR_PERS)
  references JURPERSONS (RN),
constraint C_UDOT_SLREGTRNPR_PRN_FK foreign key (PRN)
  references UDOT_SLREGTRN (RN) on delete cascade
);

/* V_UDOT_SLREGTRN */
create or replace view V_UDOT_SLREGTRN (
  NRN,
  NCOMPANY,
  NCRN,
  NJUR_PERS,
  SJUR_PERS,
  NDOC_TYPE,
  SDOCTYPES,
  SDOC_PREF,
  SDOC_NUMB,
  DDOC_DATE,
  NAGNBANKS,
  SAGNBANKS,
  NAGNJURDOCS,
  SAGNJURDOCS_BNDOCKIND,
  SAGNJURDOCS_DOCSER,
  SAGNJURDOCS_DOCNUMB,
  DAGNJURDOCS_DATE_WHEN,
  NBANKPRG,
  SBANKPRG,
  NAGNACC,
  SAGNACC,
  NSLTRTYPE,
  SSLTRTYPE,
  NAGENT,
  SAGENT,
  SFILENAME,
  DFORM_DATE,
  NHAS_PERS
) as
select
  T.RN,                                 -- nRN
  T.COMPANY,                            -- nCOMPANY
  T.CRN,                                -- nCRN
  T.JUR_PERS,                           -- nJUR_PERS
  J.CODE,                               -- sJUR_PERS
  T.DOC_TYPE,                           -- nDOC_TYPE
  D.DOCCODE,                            -- sDOCTYPES
  trim(T.DOC_PREF),                     -- sDOC_PREF
  trim(T.DOC_NUMB),                     -- sDOC_NUMB
  T.DOC_DATE,                           -- dDOC_DATE
  T.AGNBANKS,                           -- nAGNBANKS
  AGN.AGNABBR,                          -- sAGNBANKS
  T.AGNJURDOCS,                         -- nAGNJURDOCS
  B.CODE,                               -- sAGNJURDOCS_BNDOCKIND
  A2.DOCSER,                            -- sAGNJURDOCS_DOCSER
  A2.DOCNUMB,                           -- sAGNJURDOCS_DOCNUMB
  A2.DATE_WHEN,                         -- dAGNJURDOCS_DATE_WHEN
  T.BANKPRG,                            -- nBANKPRG
  B2.CODE,                              -- sBANKPRG
  T.AGNACC,                             -- nAGNACC
  A3.STRCODE,                           -- sAGNACC
  T.SLTRTYPE,                           -- nSLTRTYPE
  S.CODE,                               -- sSLTRTYPE
  J.AGENT,                              -- nAGENT
  AJ.AGNABBR,                           -- sAGENT
  T.FILENAME,                           -- sFILENAME
  T.FORM_DATE,                          -- dFORM_DATE
/*  (select \*+ INDEX(L I_DOCLINKS_IN_DOCUMENT) *\ max(L.OUT_DATE)
     from DOCLINKS L
     where L.IN_DOCUMENT = T.RN
       and L.IN_UNITCODE = 'UdotSalaryRegistersTransfers'
       and L.OUT_UNITCODE = 'BankDocuments'),-- dBANKDATE
*/
  case
    when exists (select null from UDOT_SLREGTRNPR where PRN = T.RN)
      then 1
      else 0
  end                                   -- nHAS_PERS
from
  UDOT_SLREGTRN   T,
  JURPERSONS      J,
  DOCTYPES        D,
  AGNBANKS        A,
  AGNLIST         AGN,
  AGNJURDOCS      A2,
  BNDOCKIND       B,
  BANKPRG         B2,
  AGNACC          A3,
  SLTRTYPE        S,
  AGNLIST         AJ
where T.JUR_PERS   = J.RN
  and J.AGENT      = AJ.RN
  and T.DOC_TYPE   = D.RN
  and T.AGNBANKS   = A.RN
  and A.AGNRN      = AGN.RN
  and T.AGNJURDOCS = A2.RN(+)
  and A2.BNDOCKIND = B.RN(+)
  and T.BANKPRG    = B2.RN(+)
  and T.AGNACC     = A3.RN(+)
  and T.SLTRTYPE   = S.RN(+)
  and exists (select null from V_USERPRIV UP where UP.CATALOG = T.CRN)
  and exists (select null from V_USERPRIV UP where UP.JUR_PERS = T.JUR_PERS and UP.UNITCODE = 'UdotSalaryRegistersTransfers')
;

grant select on V_UDOT_SLREGTRN to public;

create or replace function UDOT_GET_FILENAME_BANKSPB
(
  nCOMP      in number    -- 
 ,sTYPE      in varchar2  --  
 ,dDATE      in date      --  
 ,sBANKCODE  in varchar2  --     
) return varchar2
as
/*
        
     
*/

  sFILE_NAME_NEW   varchar2(80);
  nNumbFile        number(4);
  dDATE_W          date := trunc(dDATE);
begin

  update UDOT_BANKNUMBFILES m
     set m.numb = m.numb + 1
   where m.date_create = dDATE_W and m.type_file = sTYPE and m.company = nCOMP and m.bankcode = sBANKCODE
   returning m.numb into nNumbFile;

  if SQL%rowcount = 0 then
    insert into UDOT_BANKNUMBFILES
        (COMPANY, TYPE_FILE, NUMB, BANKCODE)
      values
        (nCOMP, sTYPE, 1, sBANKCODE)
      returning numb into nNumbFile;
  end if;

  if sTYPE = 'Z' then
    sFILE_NAME_NEW := 'Z'||sBANKCODE||'.'||to_char(sysdate,'dd')||trim(to_char(nNumbFile))||'.dbf';
  elsif sTYPE = 'B' then
    sFILE_NAME_NEW := 'B'||sBANKCODE||'.'||to_char(sysdate,'dd')||trim(to_char(nNumbFile))||'.dbf';
  elsif sTYPE = 'P' then
    sFILE_NAME_NEW := 'P'||sBANKCODE||'.'||to_char(sysdate,'dd')||trim(to_char(nNumbFile))||'.dbf';
  elsif sTYPE = 'N' then
    sFILE_NAME_NEW := 'N'||sBANKCODE||'.'||to_char(sysdate,'dd')||trim(to_char(nNumbFile))||'.dbf';
  else
    p_exception(0,'   - '||sTYPE);
  end if;
  return sFILE_NAME_NEW;
end UDOT_GET_FILENAME_BANKSPB;
/

grant execute on UDOT_GET_FILENAME_BANKSPB to public;

create or replace procedure P_UDOT_SLREGTRN_BASE_GETNEXTN
(
  nCOMPANY           in number,
  nJUR_PERS          in number,
  dDOC_DATE          in date,
  nDOCTYPES          in number,
  sDOC_PREF          in varchar2,
  sDOC_NUMB          out varchar2
)
as
begin
  PKG_DOCUMENT.NEXT_NUMBER( nCOMPANY, 80, '', 'UDOT_SLREGTRN', 'JPERS', 'DOC_YEAR', 'DOC_TYPE', 'DOC_PREF', 'DOC_NUMB',
    null, null, null, null, null, null, null,
    null, nJUR_PERS, D_YEAR(dDOC_DATE), nDOCTYPES, sDOC_PREF, sDOC_NUMB );
end P_UDOT_SLREGTRN_BASE_GETNEXTN;
/

create or replace procedure P_UDOT_SLREGTRN_GETNEXTNUMB
(
  nCOMPANY      in number,
  sJUR_PERS     in varchar2,
  sDOCTYPES     in varchar2,
  sDOC_PREF     in varchar2,
  dDOC_DATE     in date,
  sDOC_NUMB     out varchar2
)
as
  nDOCTYPES     PKG_STD.tREF;
  nJUR_PERS     PKG_STD.tREF;
begin
  if rtrim(sDOCTYPES) is null or rtrim(sJUR_PERS) is null then
    return;
  end if;

  FIND_DOCTYPES_CODE_EX( 0,0,nCOMPANY,sDOCTYPES,nDOCTYPES );
  FIND_JURPERSONS_CODE( 0,0,nCOMPANY,sJUR_PERS,nJUR_PERS );

  P_UDOT_SLREGTRN_BASE_GETNEXTN(nCOMPANY, nJUR_PERS, dDOC_DATE, nDOCTYPES, sDOC_PREF, sDOC_NUMB);
end P_UDOT_SLREGTRN_GETNEXTNUMB;
/

grant execute on P_UDOT_SLREGTRN_GETNEXTNUMB to public;

create index I_UDOT_SLREGTRN_SLTRTYPE_FK on UDOT_SLREGTRN(SLTRTYPE) tablespace &INDX_B1709;

create or replace procedure P_UDOT_SLREGTRN_BASE_INSERT
(
  nCOMPANY                  in number,       -- 
  nCRN                      in number,       -- 
  nJUR_PERS                 in number,       -- 
  nDOC_TYPE                 in number,       --   (  DOCTYPES(RN))
  sDOC_PREF                 in varchar2,     --   
  sDOC_NUMB                 in varchar2,     --  
  dDOC_DATE                 in date,         --  
  nAGNBANKS                 in number,       --  ()
  nAGNJURDOCS               in number,       -- 
  nBANKPRG                  in number,       --  
  nAGNACC                   in number,       --  /  
  nSLTRTYPE                 in number,       --  
  dFORM_DATE                in date,         --  
  nRN                       out number       --  
)
as
begin
  /*    */
  nRN := gen_id;

  /*     */
  insert into UDOT_SLREGTRN
  (
    RN,
    COMPANY,
    CRN,
    JUR_PERS,
    DOC_TYPE,
    DOC_PREF,
    DOC_NUMB,
    DOC_DATE,
    AGNBANKS,
    AGNJURDOCS,
    BANKPRG,
    AGNACC,
    SLTRTYPE,
    FORM_DATE
  )
  values
  (
    nRN,
    nCOMPANY,
    nCRN,
    nJUR_PERS,
    nDOC_TYPE,
    sDOC_PREF,
    sDOC_NUMB,
    dDOC_DATE,
    nAGNBANKS,
    nAGNJURDOCS,
    nBANKPRG,
    nAGNACC,
    nSLTRTYPE,
    dFORM_DATE
  );
end P_UDOT_SLREGTRN_BASE_INSERT;
/

create index I_UDOT_SLREGTRN_AGNACC_FK on UDOT_SLREGTRN(AGNACC) tablespace &INDX_B1709;

create or replace trigger T_UDOT_SLREGTRN_AUPDATE
  after update on UDOT_SLREGTRN for each row
begin
  /*       */
  P_LOG_UPDATE( :new.RN,'UdotSalaryRegistersTransfers',:new.CRN,:old.CRN,:new.JUR_PERS,:old.JUR_PERS );
end;
/

create index I_UDOT_SLREGTRN_JUR_PERS_FK on UDOT_SLREGTRN(JUR_PERS) tablespace &INDX_B1709;

create index I_UDOT_SLREGTRN_AGNJURDOCS_FK on UDOT_SLREGTRN(AGNJURDOCS) tablespace &INDX_B1709;

create or replace procedure P_UDOT_SLREGTRN_BASE_UPDATE
(
  nRN                       in number,       --  
  nCOMPANY                  in number,       -- 
  nJUR_PERS                 in number,       -- 
  nDOC_TYPE                 in number,       --   (  DOCTYPES(RN))
  sDOC_PREF                 in varchar2,     --   
  sDOC_NUMB                 in varchar2,     --  
  dDOC_DATE                 in date,         --  
  nAGNBANKS                 in number,       --  ()
  nAGNJURDOCS               in number,       -- 
  nBANKPRG                  in number,       --  
  nAGNACC                   in number,       --  /  
  nSLTRTYPE                 in number        --  
)
as
begin
  /*     */
  update UDOT_SLREGTRN
     set JUR_PERS = nJUR_PERS,
         DOC_TYPE = nDOC_TYPE,
         DOC_PREF = sDOC_PREF,
         DOC_NUMB = sDOC_NUMB,
         DOC_DATE = dDOC_DATE,
         AGNBANKS = nAGNBANKS,
         AGNJURDOCS = nAGNJURDOCS,
         BANKPRG = nBANKPRG,
         AGNACC = nAGNACC,
         SLTRTYPE = nSLTRTYPE
   where RN = nRN
     and COMPANY = nCOMPANY;

  if (SQL%NOTFOUND) then
    PKG_MSG.RECORD_NOT_FOUND( nRN,'UdotSalaryRegistersTransfers' );
  end if;
end P_UDOT_SLREGTRN_BASE_UPDATE;
/

create or replace trigger T_UDOT_SLREGTRN_BDELETE
  before delete on UDOT_SLREGTRN for each row
declare
  nRESULT         number( 17 );
begin
  /*     dbf */
  if nvl(dbms_lob.getlength(:old.bdata),0) > 0 then
    p_exception(0, '    dbf .  .');
  end if;
  /*     */
  P_DOCINPT_FIND_EXACT( 0, :old.COMPANY, 'UdotSalaryRegistersTransfers', :old.RN, nRESULT);
  /*      */
  P_LINKSALL_DELETE_FULL_OUT( :old.COMPANY,'UdotSalaryRegistersTransfers',:old.RN );

  /*   */
  if ( PKG_IUD.PROLOGUE('UDOT_SLREGTRN', 'D') ) then
    PKG_IUD.REG_RN('RN', :old.RN);
    PKG_IUD.REG_COMPANY('COMPANY', :old.COMPANY);
    PKG_IUD.REG_CRN('CRN', :old.CRN);
    PKG_IUD.REG_JUR_PERS(1, 'JUR_PERS', :old.JUR_PERS, 'JURPERSONS', 'CODE');
    PKG_IUD.REG( 'JPERS',:old.JPERS );
    PKG_IUD.REG(2, 'DOC_TYPE', :old.DOC_TYPE, 'DOCTYPES', 'DOCCODE');
    PKG_IUD.REG(3, 'DOC_PREF', :old.DOC_PREF);
    PKG_IUD.REG(4, 'DOC_NUMB', :old.DOC_NUMB);
    PKG_IUD.REG(5, 'DOC_DATE', :old.DOC_DATE);
    PKG_IUD.REG( 'DOC_YEAR',:old.DOC_YEAR );
    PKG_IUD.REG('AGNBANKS', :old.AGNBANKS);
    PKG_IUD.REG('AGNJURDOCS', :old.AGNJURDOCS);
    PKG_IUD.REG('BANKPRG', :old.BANKPRG);
    PKG_IUD.REG('AGNACC', :old.AGNACC);
    PKG_IUD.REG('SLTRTYPE', :old.SLTRTYPE);
    PKG_IUD.REG('FILENAME', :old.FILENAME);
    PKG_IUD.REG('FORM_DATE', :old.FORM_DATE);
    PKG_IUD.EPILOGUE;
  end if;
end T_UDOT_SLREGTRN_BDELETE;
/

create index I_UDOT_SLREGTRN_BANKPRG_FK on UDOT_SLREGTRN(BANKPRG) tablespace &INDX_B1709;

create index I_UDOT_SLREGTRN_AGNBANKS_FK on UDOT_SLREGTRN(AGNBANKS) tablespace &INDX_B1709;

create index I_UDOT_SLREGTRN_DOC_TYPE_FK on UDOT_SLREGTRN(DOC_TYPE) tablespace &INDX_B1709;

create index I_UDOT_SLREGTRN_CRN_FK on UDOT_SLREGTRN(CRN) tablespace &INDX_B1709;

create or replace trigger T_UDOT_SLREGTRN_ADELETE
  after delete on UDOT_SLREGTRN for each row
begin
  /*       */
  P_LOG_DELETE( :old.RN,'UdotSalaryRegistersTransfers' );
end;
/

create or replace trigger T_UDOT_SLREGTRN_BUPDATE
  before update on UDOT_SLREGTRN for each row
begin
  /*     */
  PKG_UNCHANGE.CHECK_NE('UDOT_SLREGTRN', 'RN', :new.RN, :old.RN);
  PKG_UNCHANGE.CHECK_NE('UDOT_SLREGTRN', 'COMPANY', :new.COMPANY, :old.COMPANY);
  PKG_UNCHANGE.CHECK_NE('UDOT_SLREGTRN', 'JUR_PERS', :new.JUR_PERS, :old.JUR_PERS);

  /*       */
  if ( CMP_NUM(:new.CRN,:old.CRN) = 1 ) then
    /*     dbf */
    if nvl(dbms_lob.getlength(:old.bdata),0) > 0 and nvl(dbms_lob.getlength(:new.bdata),0) > 0 then
      p_exception(0, '    dbf .  .');
    end if;
    /*   */
    :new.DOC_NUMB := trimnumb( :new.DOC_NUMB, 80 );
    /*   */
    :new.DOC_PREF := trimnumb( :new.DOC_PREF, 80 );
    /*       */
    :new.JPERS     := :new.JUR_PERS;
    :new.DOC_YEAR  := d_year(:new.DOC_DATE);
  end if;

  /*   */
  if ( PKG_IUD.PROLOGUE('UDOT_SLREGTRN', 'U') ) then
    PKG_IUD.REG_RN('RN', :new.RN, :old.RN);
    PKG_IUD.REG_COMPANY('COMPANY', :new.COMPANY, :old.COMPANY);
    PKG_IUD.REG_CRN('CRN', :new.CRN, :old.CRN);
    PKG_IUD.REG_JUR_PERS(1, 'JUR_PERS', :new.JUR_PERS, :old.JUR_PERS, 'JURPERSONS', 'CODE');
    PKG_IUD.REG( 'JPERS',:new.JPERS,:old.JPERS );
    PKG_IUD.REG(2, 'DOC_TYPE', :new.DOC_TYPE, :old.DOC_TYPE, 'DOCTYPES', 'DOCCODE');
    PKG_IUD.REG(3, 'DOC_PREF', :new.DOC_PREF, :old.DOC_PREF);
    PKG_IUD.REG(4, 'DOC_NUMB', :new.DOC_NUMB, :old.DOC_NUMB);
    PKG_IUD.REG(5, 'DOC_DATE', :new.DOC_DATE, :old.DOC_DATE);
    PKG_IUD.REG( 'DOC_YEAR',:new.DOC_YEAR,:old.DOC_YEAR );
    PKG_IUD.REG('AGNBANKS', :new.AGNBANKS, :old.AGNBANKS);
    PKG_IUD.REG('AGNJURDOCS', :new.AGNJURDOCS, :old.AGNJURDOCS);
    PKG_IUD.REG('BANKPRG', :new.BANKPRG, :old.BANKPRG);
    PKG_IUD.REG('AGNACC', :new.AGNACC, :old.AGNACC);
    PKG_IUD.REG('SLTRTYPE', :new.SLTRTYPE, :old.SLTRTYPE);
    PKG_IUD.REG('FILENAME', :new.FILENAME, :old.FILENAME);
    PKG_IUD.REG('FORM_DATE', :new.FORM_DATE, :old.FORM_DATE);
    PKG_IUD.EPILOGUE;
  end if;
end T_UDOT_SLREGTRN_BUPDATE;
/

create or replace procedure P_UDOT_SLREGTRN_EXISTS
(
  nRN                       in number       --  
 ,nCOMPANY                  in number       -- 
 ,nCRN                      out number      -- 
 ,nJUR_PERS                 out number      -- 
 ,nIS_UNLOAD                out number      --     dbf
)
as
begin
  /*   */
  begin
    select R.CRN, R.JUR_PERS, sign(nvl(dbms_lob.getlength(R.BDATA),0))
      into nCRN, nJUR_PERS, nIS_UNLOAD
      from UDOT_SLREGTRN  R
     where R.RN = nRN
       and COMPANY = nCOMPANY;
  exception
    when NO_DATA_FOUND then
      PKG_MSG.RECORD_NOT_FOUND( nRN,'UdotSalaryRegistersTransfers' );
  end;
end P_UDOT_SLREGTRN_EXISTS;
/

grant execute on P_UDOT_SLREGTRN_EXISTS to public;

create or replace trigger T_UDOT_SLREGTRN_BINSERT
  before insert on UDOT_SLREGTRN for each row
begin

  /*   */
  :new.DOC_NUMB := trimnumb( :new.DOC_NUMB,80 );

  /*   */
  :new.DOC_PREF := trimnumb( :new.DOC_PREF,80 );

  /*       */
  :new.JPERS     := :new.JUR_PERS;
  :new.DOC_YEAR  := d_year(:new.DOC_DATE);

  /*   */
  if ( PKG_IUD.PROLOGUE('UDOT_SLREGTRN', 'I') ) then
    PKG_IUD.REG_RN('RN', :new.RN);
    PKG_IUD.REG_COMPANY('COMPANY', :new.COMPANY);
    PKG_IUD.REG_CRN('CRN', :new.CRN);
    PKG_IUD.REG_JUR_PERS(1, 'JUR_PERS', :new.JUR_PERS, 'JURPERSONS', 'CODE');
    PKG_IUD.REG( 'JPERS',:new.JPERS );
    PKG_IUD.REG(2, 'DOC_TYPE', :new.DOC_TYPE, 'DOCTYPES', 'DOCCODE');
    PKG_IUD.REG(3, 'DOC_PREF', :new.DOC_PREF);
    PKG_IUD.REG(4, 'DOC_NUMB', :new.DOC_NUMB);
    PKG_IUD.REG(5, 'DOC_DATE', :new.DOC_DATE);
    PKG_IUD.REG( 'DOC_YEAR',:new.DOC_YEAR );
    PKG_IUD.REG('AGNBANKS', :new.AGNBANKS);
    PKG_IUD.REG('AGNJURDOCS', :new.AGNJURDOCS);
    PKG_IUD.REG('BANKPRG', :new.BANKPRG);
    PKG_IUD.REG('AGNACC', :new.AGNACC);
    PKG_IUD.REG('SLTRTYPE', :new.SLTRTYPE);
    PKG_IUD.REG('FILENAME', :new.FILENAME);
    PKG_IUD.REG('FORM_DATE', :new.FORM_DATE);
    PKG_IUD.EPILOGUE;
  end if;
end T_UDOT_SLREGTRN_BINSERT;
/

create or replace procedure P_UDOT_SLREGTRN_BASE_DELETE
(
  nRN                       in number,       --  
  nCOMPANY                  in number        -- 
)
as
begin
  /*     */
  delete
    from UDOT_SLREGTRN
   where RN = nRN
     and COMPANY = nCOMPANY;

  if (SQL%NOTFOUND) then
    PKG_MSG.RECORD_NOT_FOUND( nRN,'UdotSalaryRegistersTransfers' );
  end if;
end P_UDOT_SLREGTRN_BASE_DELETE;
/

create or replace procedure P_UDOT_SLREGTRN_CREAR_DBF
(
  nCOMPANY     in number    -- 
 ,nRN          in number    -- RN  
)
as
  nJUR_PERS         pkg_std.tref;
  nCRN              pkg_std.tref;
  nTMP              pkg_std.tref;
  nIS_UNLOAD        pkg_std.tref;
begin
  /*   */
  P_UDOT_SLREGTRN_EXISTS
  (
    nRN         => nRN         --  
   ,nCOMPANY    => nCOMPANY    -- 
   ,nCRN        => nCRN        -- 
   ,nJUR_PERS   => nJUR_PERS   -- 
   ,nIS_UNLOAD  => nIS_UNLOAD  --  
  );
  --   
  if nIS_UNLOAD = 0 then
    p_exception(0,'  RN='||nRN||'     dbf.');
  end if;

  /*     */
  PKG_ENV.PROLOGUE( nCOMPANY,null,nCRN,nJUR_PERS,null,'UdotSalaryRegistersTransfers','UDOT_SLREGTRN_CREAR_DBF','UDOT_SLREGTRN', nRN );

  --    ,      
  update UDOT_SLREGTRN u
     set u.bdata = empty_blob()
        ,u.filename = ''
   where u.rn = nRN;

  /*     */
  PKG_ENV.EPILOGUE( nCOMPANY,null,nCRN,nJUR_PERS,null,'UdotSalaryRegistersTransfers','UDOT_SLREGTRN_CREAR_DBF','UDOT_SLREGTRN',nRN );
end P_UDOT_SLREGTRN_CREAR_DBF;
/

grant execute on P_UDOT_SLREGTRN_CREAR_DBF to public;

create or replace procedure P_UDOT_SLREGTRN_INSERT
(
  nCOMPANY                  in number,       -- 
  nCRN                      in number,       -- 
  sAGENT                    in varchar2,     --   
  sJUR_PERS                 in varchar2,     --  ()
  sDOCTYPES                 in varchar2,     --   ()
  sDOC_PREF                 in varchar2,     --   
  sDOC_NUMB                 in varchar2,     --  
  dDOC_DATE                 in date,         --  
  sAGNBANKS                 in varchar2,     --  () ()
  nAGNJURDOCS               in number,       -- 
  sBANKPRG                  in varchar2,     --   ()
--  sAGNACC                   in varchar2,     --  /   ( )
  sSLTRTYPE                 in varchar2,     --   ()
  nRN                       out number       --  
)
as
  nJUR_PERS                 PKG_STD.tREF;    -- 
  nDOC_TYPE                 PKG_STD.tREF;    --   (  DOCTYPES(RN))
  nAGNBANKS                 PKG_STD.tREF;    --  ()
  nBANKPRG                  PKG_STD.tREF;    --  
  nAGNACC                   PKG_STD.tREF;    --  /  
  nSLTRTYPE                 PKG_STD.tREF;    --  
  nAGENT                    agnlist.rn%type;         --  
--  sAGENT_W                  agnlist.agnabbr%type;    --  
begin
  --   
  find_agnlist_by_mnemo( 0, nCOMPANY, sAGENT, nAGENT);
--  FIND_JURPERSONS_ALL
  /*   */
  P_UDOT_SLREGTRN_JOINS
  (
    nCOMPANY,
    nAGENT,
    sJUR_PERS,
    sDOCTYPES,
    sAGNBANKS,
    sBANKPRG,
    '',          -- sAGNACC,
    sSLTRTYPE,
    nJUR_PERS,
    nDOC_TYPE,
    nAGNBANKS,
    nBANKPRG,
    nAGNACC,
    nSLTRTYPE
  );

  /*     */
  PKG_ENV.PROLOGUE( nCOMPANY,null,nCRN,nJUR_PERS,null,'UdotSalaryRegistersTransfers','UDOT_SLREGTRN_INSERT','UDOT_SLREGTRN' );

  /*   */
  P_UDOT_SLREGTRN_BASE_INSERT
  (
    nCOMPANY,
    nCRN,
    nJUR_PERS,
    nDOC_TYPE,
    sDOC_PREF,
    sDOC_NUMB,
    dDOC_DATE,
    nAGNBANKS,
    nAGNJURDOCS,
    nBANKPRG,
    nAGNACC,
    nSLTRTYPE,
    null,
    nRN
  );

  /*     */
  PKG_ENV.EPILOGUE( nCOMPANY,null,nCRN,nJUR_PERS,null,'UdotSalaryRegistersTransfers','UDOT_SLREGTRN_INSERT','UDOT_SLREGTRN',nRN );
end P_UDOT_SLREGTRN_INSERT;
/

grant execute on P_UDOT_SLREGTRN_INSERT to public;

create or replace procedure P_UDOT_SLREGTRN_MOVE
(
  nCOMPANY      in number,
  nRN           in number,
  nCRN          in number
)
as
  nCRN1         PKG_STD.tREF;
  nJUR_PERS     PKG_STD.tREF;
  nIS_UNLOAD    pkg_std.tref;
begin
  /*   */
  P_UDOT_SLREGTRN_EXISTS ( nCOMPANY, nRN, nCRN1, nJUR_PERS, nIS_UNLOAD);

  /*     */
  PKG_ENV.PROLOGUE( nCOMPANY, null, nCRN1, nJUR_PERS, 'UdotSalaryRegistersTransfers', 'UDOT_SLREGTRN_MOVE_OUT', 'UDOT_SLREGTRN', nRN );
  PKG_ENV.PROLOGUE( nCOMPANY, null, nCRN, nJUR_PERS,  'UdotSalaryRegistersTransfers', 'UDOT_SLREGTRN_MOVE_IN',  'UDOT_SLREGTRN', nRN );

  /*   */
  update UDOT_SLREGTRN
     set CRN = nCRN
    where RN = nRN
      and COMPANY = nCOMPANY;

  if ( SQL%NOTFOUND ) then
    PKG_MSG.RECORD_NOT_FOUND( nRN,'UdotSalaryRegistersTransfers' );
  end if;

  /*     */
  PKG_ENV.EPILOGUE( nCOMPANY, null, nCRN1, nJUR_PERS, 'UdotSalaryRegistersTransfers', 'UDOT_SLREGTRN_MOVE_OUT', 'UDOT_SLREGTRN', nRN );
  PKG_ENV.EPILOGUE( nCOMPANY, null, nCRN, nJUR_PERS,  'UdotSalaryRegistersTransfers', 'UDOT_SLREGTRN_MOVE_IN',  'UDOT_SLREGTRN', nRN );
end P_UDOT_SLREGTRN_MOVE;
/

grant execute on P_UDOT_SLREGTRN_MOVE to public;

create or replace procedure P_UDOT_SLREGTRN_DELETE
(
  nRN                       in number,       --  
  nCOMPANY                  in number        -- 
)
as
  nCRN              PKG_STD.tREF;    -- 
  nJUR_PERS         PKG_STD.tREF;    -- 
  nIS_UNLOAD        pkg_std.tref;
begin
  /*   */
  P_UDOT_SLREGTRN_EXISTS
  (
    nRN,
    nCOMPANY,
    nCRN,
    nJUR_PERS,
    nIS_UNLOAD
  );

  /*     */
  PKG_ENV.PROLOGUE( nCOMPANY,null,nCRN,nJUR_PERS,null,'UdotSalaryRegistersTransfers','UDOT_SLREGTRN_DELETE','UDOT_SLREGTRN',nRN );

  /*   */
  P_UDOT_SLREGTRN_BASE_DELETE
  (
    nRN,
    nCOMPANY
  );

  /*     */
  PKG_ENV.EPILOGUE( nCOMPANY,null,nCRN,nJUR_PERS,null,'UdotSalaryRegistersTransfers','UDOT_SLREGTRN_DELETE','UDOT_SLREGTRN',nRN );
end;
/

grant execute on P_UDOT_SLREGTRN_DELETE to public;

create or replace procedure P_UDOT_SLREGTRN_UPDATE
(
  nRN                       in number,       --  
  nCOMPANY                  in number,       -- 
  sAGENT                    in varchar2,     --  
  sJUR_PERS                 in varchar2,     --  ()
  sDOCTYPES                 in varchar2,     --   ()
  sDOC_PREF                 in varchar2,     --   
  sDOC_NUMB                 in varchar2,     --  
  dDOC_DATE                 in date,         --  
  sAGNBANKS                 in varchar2,     --  () ()
  nAGNJURDOCS               in number,       -- 
  sBANKPRG                  in varchar2,     --   ()
--  sAGNACC                   in varchar2,     --  /   ( )
  sSLTRTYPE                 in varchar2      --   ()
)
as
  nCRN                      PKG_STD.tREF;    -- 
  nJUR_PERS                 PKG_STD.tREF;    -- 
  nDOC_TYPE                 PKG_STD.tREF;    --   (  DOCTYPES(RN))
  nAGNBANKS                 PKG_STD.tREF;    --  ()
  nBANKPRG                  PKG_STD.tREF;    --  
  nAGNACC                   PKG_STD.tREF;    --  /  
  nSLTRTYPE                 PKG_STD.tREF;    --  
  nAGENT                    agnlist.rn%type; --  
  nIS_UNLOAD                pkg_std.tref;
begin
  --   
  find_agnlist_by_mnemo( 0, nCOMPANY, sAGENT, nAGENT);
  /*   */
  P_UDOT_SLREGTRN_EXISTS
  (
    nRN         => nRN         --  
   ,nCOMPANY    => nCOMPANY    -- 
   ,nCRN        => nCRN        -- 
   ,nJUR_PERS   => nJUR_PERS   -- 
   ,nIS_UNLOAD  => nIS_UNLOAD  --  
  );

  /*     */
  PKG_ENV.PROLOGUE( nCOMPANY,null,nCRN,nJUR_PERS,null,'UdotSalaryRegistersTransfers','UDOT_SLREGTRN_UPDATE','UDOT_SLREGTRN',nRN );

  /*   */
  P_UDOT_SLREGTRN_JOINS
  (
    nCOMPANY,
    nAGENT,
    sJUR_PERS,
    sDOCTYPES,
    sAGNBANKS,
    sBANKPRG,
    '',         -- sAGNACC,
    sSLTRTYPE,
    nJUR_PERS,
    nDOC_TYPE,
    nAGNBANKS,
    nBANKPRG,
    nAGNACC,
    nSLTRTYPE
  );

  /*   */
  P_UDOT_SLREGTRN_BASE_UPDATE
  (
    nRN,
    nCOMPANY,
    nJUR_PERS,
    nDOC_TYPE,
    sDOC_PREF,
    sDOC_NUMB,
    dDOC_DATE,
    nAGNBANKS,
    nAGNJURDOCS,
    nBANKPRG,
    nAGNACC,
    nSLTRTYPE
  );

  /*     */
  PKG_ENV.EPILOGUE( nCOMPANY,null,nCRN,nJUR_PERS,null,'UdotSalaryRegistersTransfers','UDOT_SLREGTRN_UPDATE','UDOT_SLREGTRN',nRN );
end P_UDOT_SLREGTRN_UPDATE;
/

grant execute on P_UDOT_SLREGTRN_UPDATE to public;

create or replace procedure                               P_UDOT_SLREGTRN_MAKE_DBF
(
  nCOMPANY     in number    -- 
 ,nRN          in number    --   
 ,sDOP_ORG     in varchar2  --     
 ,sDOP_GEO     in varchar2  --          ()
 ,nSIGN_OLD_V  in number    --     
 ,nPROCESS     in number    --  
 ,sMSG         out varchar2 --   
)
as
  nDOCS_PROPS_ORG   pkg_std.tref;
  nDOP_GEO          pkg_std.tref;
  nJUR_PERS         pkg_std.tref;
  nCRN              pkg_std.tref;
  nTMP              pkg_std.tref;
  sMSG_W            varchar2(32000) := '';
  sTMP_C            varchar2(2000);
  cCLOB             clob;
  bBLOB             blob;
  sFILENAME         varchar2(160);
  sFILENAME_SAVE    varchar2(160);
  sCOMP_CODE        varchar2(40);
  rCURRENT_PERS     BANK_SPB_BFF_DBF%rowtype;
  nIS_UNLOAD        number;
  nCOUNT_ERR        number := 0; --  
  nCOUNT_PERS       number := 0; --   
  nSUMM_ALL         number := 0;
  --  
  cursor cCUR
  (
    nDOC              number,
    nDOCS_PROPS_ORG   number,
    nDOP_GEO          number
  )
  is
  select c.agnacc
        ,a.agnabbr
        ,p.trn_sum
        ,(select s.code from inctransftyp s where p.kvdrn = s.rn) as code
        ,p.fz229_sum        
        ,a.agnfamilyname||' '||a.agnfirstname||' '||a.agnlastname  as sfio
        ,(select d.docser||' '||d.docnumb||'@'||
                 (select dv.str_value from DOCS_PROPS_VALS dv
                   where dv.unitcode = 'GEOGRAFY' and dv.unit_rn = tp.country
                     and dv.docs_prop_rn = nDOP_GEO--189193876
                 )
            from agndocums    d
                ,agnpasstype  tp
           where d.prn = p.agnlist and d.default_sign = 1
             and d.agnpasstype = tp.rn
         )                                                         as spasport
        ,(select (select dv.str_value from DOCS_PROPS_VALS dv
                   where dv.unitcode = 'AGNLIST' and dv.unit_rn = j.agent
                     and dv.docs_prop_rn = nDOCS_PROPS_ORG--200824720
                 )
            from jurpersons j
           where j.rn = p.jur_pers
         )                                                         as scompany
    from UDOT_SLREGTRNPR p
        ,AGNLIST         a
        ,AGNACC          c
--        ,INCTRANSFTYP    s
   where p.prn = nDOC--200972254
     and p.agnlist = a.rn
     and p.agnacc = c.rn(+);
--     and (p.kvdrn = s.rn or p.kvdrn is null)

  --        
  procedure WRITE_FIELD_CONTROL
  (
    sFIELD      in varchar2
   ,dDATE_VAL   in date default null
   ,nNUMB_VAL   in number default null
   ,sSTR_VAL    in varchar2 default null
  )
  as
    error_field_name  exception;
    error_data_vals   exception;
    sTYPE             varchar2(40);
  begin
    if not (dDATE_VAL is null and nNUMB_VAL is null and sSTR_VAL is null
            or dDATE_VAL is null and nNUMB_VAL is null and sSTR_VAL is not null
            or dDATE_VAL is null and nNUMB_VAL is not null and sSTR_VAL is null
            or dDATE_VAL is not null and nNUMB_VAL is null and sSTR_VAL is null
           )
    then
      raise error_data_vals;
    end if;
    if upper(sFIELD) = 'SBK_NUM' then
      sTYPE  := '(20)';
      rCURRENT_PERS.sbk_num := sSTR_VAL;
    elsif upper(sFIELD) = 'SBK_SUM' then
      sTYPE  := '(15,2)';
      rCURRENT_PERS.sbk_sum := nNUMB_VAL;
    elsif upper(sFIELD) = 'SBK_FIO' then
      sTYPE  := '(96)';
      rCURRENT_PERS.sbk_fio := sSTR_VAL;
    elsif upper(sFIELD) = 'SBK_PAS' then
      sTYPE  := '(20)';
      rCURRENT_PERS.sbk_pas := sSTR_VAL;
    elsif upper(sFIELD) = 'COMPANY' then
      sTYPE  := '(15)';
      rCURRENT_PERS.company := nNUMB_VAL;
    elsif upper(sFIELD) = 'TABNOM' then
      sTYPE  := '(10)';
      rCURRENT_PERS.tabnom := nNUMB_VAL;
    elsif upper(sFIELD) = 'EDICATION' then
      sTYPE  := '(15)';
      rCURRENT_PERS.education := nNUMB_VAL;
    elsif upper(sFIELD) = 'CONTRACTNO' then
      sTYPE  := '(20)';
      rCURRENT_PERS.contractno := sSTR_VAL;
    elsif upper(sFIELD) = 'BIRTHDAY' then
      sTYPE  := '';
      rCURRENT_PERS.birthday := dDATE_VAL;
    elsif upper(sFIELD) = 'CODE' then
      sTYPE  := '(1)';
      rCURRENT_PERS.code := sSTR_VAL;
    elsif upper(sFIELD) = 'FZ229_SUM' then
      sTYPE  := '(15,2)';
      rCURRENT_PERS.fz229_sum := nNUMB_VAL;
    else
      raise error_field_name;
    end if;
  exception
    when error_field_name then
      p_exception(0,'     "'||sFIELD||'"');
    when error_data_vals then
      p_exception(0, '    "'||sFIELD||'"     ,   (dDATE="'||dDATE_VAL||'", nNUMB="'||nNUMB_VAL||'", sSTRING="'||sSTR_VAL||'")');
    when others then
      p_exception(0, '  "'||rCURRENT_PERS.sbk_fio||'"     "'||sFIELD||'"       :  - "'||sTYPE||'",   (dDATE="'||dDATE_VAL||'", nNUMB="'||nNUMB_VAL||'", sSTRING="'||sSTR_VAL||'")');
  end WRITE_FIELD_CONTROL;

begin
  /*   */
  P_UDOT_SLREGTRN_EXISTS
  (
    nRN         => nRN         --  
   ,nCOMPANY    => nCOMPANY    -- 
   ,nCRN        => nCRN        -- 
   ,nJUR_PERS   => nJUR_PERS   -- 
   ,nIS_UNLOAD  => nIS_UNLOAD  --     dbf
  );

  if nIS_UNLOAD > 0 then
    p_exception(0,'  RN='||nRN||'     dbf.      .');
  end if;
  --  
  find_docs_props_code(0, nCOMPANY, sDOP_ORG, nDOCS_PROPS_ORG);
  find_docs_props_code(0, nCOMPANY, sDOP_GEO, nDOP_GEO);

  /*     */
  PKG_ENV.PROLOGUE( nCOMPANY,null,nCRN,nJUR_PERS,null,'UdotSalaryRegistersTransfers','UDOT_SLREGTRN_MAKE_DBF','UDOT_SLREGTRN', nRN );

  --   
  begin
    select (select dv.str_value from DOCS_PROPS_VALS dv
             where dv.unitcode = 'AGNLIST' and dv.unit_rn = j.agent
               and dv.docs_prop_rn = nDOCS_PROPS_ORG--200824720
           )         as  sCOMPANY
      into sCOMP_CODE
      from jurpersons j
     where j.rn = nJUR_PERS;
    if trim(sCOMP_CODE) is null then
      p_exception(0, '       "    "     .');
    elsif length(trim(sCOMP_CODE)) <> 9 then
      p_exception(0, '   "    "            9  ('||trim(sCOMP_CODE)||').');
    end if;
  exception
    when no_data_found then
      p_exception(0, '       "    "     .');
  end;
  --         
  sFILENAME   := substr(sCOMP_CODE, 3, 2)||substr(sCOMP_CODE, 1, 2)||'_'||substr(sCOMP_CODE, 5);

  dbms_lob.createtemporary(cCLOB, true, dbms_lob.call);
  nCOUNT_ERR   := 0;
  nCOUNT_PERS  := 0;

  --    (        )
  for rc in cCUR
  (
    nRN, nDOCS_PROPS_ORG, nDOP_GEO
  ) loop
    sMSG_W  := CR;
    if instr(rc.spasport,'@RU') > 0 then
      sTMP_C := regexp_substr(rc.spasport,'^([[:digit:]]{2})(['||' '||'])([[:digit:]]{2})(['||' '||'])([[:digit:]]{6})@');
      if sTMP_C is null then
        sMSG_W := sMSG_W||':       : '||rc.sfio||' - "'||substr(rc.spasport,1,instr(rc.spasport,'@')-1)||'"'||CR||'         (           - "RU" )'||CR;
        dbms_lob.writeappend(cCLOB, length(sMSG_W), sMSG_W);
        nCOUNT_ERR := nCOUNT_ERR + 1;
        sMSG_W  := '';
      end if;
    end if;
    rc.spasport := substr(rc.spasport,1,instr(rc.spasport,'@')-1);
    if trim(rc.sfio) is null then
      sMSG_W := sMSG_W||':     "'||rc.agnabbr||'"  ,    "'||rc.sfio||'"'||CR;
      dbms_lob.writeappend(cCLOB, length(sMSG_W), sMSG_W);
      nCOUNT_ERR := nCOUNT_ERR + 1;
      sMSG_W  := '';
    end if;
    if rc.spasport is null then
      sMSG_W := sMSG_W||':   '||rc.sfio||'    - "'||rc.spasport||'",       ""'||CR;
      dbms_lob.writeappend(cCLOB, length(sMSG_W), sMSG_W);
      nCOUNT_ERR := nCOUNT_ERR + 1;
      sMSG_W  := '';
    end if;
    if nvl(rc.trn_sum,0) <= 0 then
      sMSG_W := sMSG_W||':   '||rc.sfio||'      0 - "'||rc.trn_sum||'"'||CR;
      dbms_lob.writeappend(cCLOB, length(sMSG_W), sMSG_W);
      nCOUNT_ERR := nCOUNT_ERR + 1;
      sMSG_W  := '';
    end if;
    rCURRENT_PERS := null;
--    rCURRENT_PERS.Company := sCOMP_CODE;
    WRITE_FIELD_CONTROL(sFIELD => 'SBK_NUM',   sSTR_VAL => rc.agnacc );
    WRITE_FIELD_CONTROL(sFIELD => 'SBK_SUM',   nNUMB_VAL => rc.trn_sum );
    WRITE_FIELD_CONTROL(sFIELD => 'SBK_FIO',   sSTR_VAL => rc.sfio );
    WRITE_FIELD_CONTROL(sFIELD => 'SBK_PAS',   sSTR_VAL => rc.spasport );
    WRITE_FIELD_CONTROL(sFIELD => 'COMPANY',   nNUMB_VAL => sCOMP_CODE );
    WRITE_FIELD_CONTROL(sFIELD => 'CODE',      sSTR_VAL => rc.code );
    WRITE_FIELD_CONTROL(sFIELD => 'FZ229_SUM', nNUMB_VAL => rc.fz229_sum );
    nCOUNT_PERS  := nCOUNT_PERS + 1;
    insert into BANK_SPB_BFF_DBF
     values rCURRENT_PERS;
    --    
    nSUMM_ALL  := nSUMM_ALL + rc.trn_sum;
--    insert into BANK_SPB_BFF_DBF
--        (SBK_NUM, SBK_SUM, SBK_FIO, SBK_PAS, COMPANY)
--      values
--        (rc.agnacc, rc.trn_sum, rc.sfio, rc.spasport, to_number(sCOMP_CODE));
  end loop;

  --        
  sFILENAME_SAVE := 'B'||sFILENAME||'.log';
  if nCOUNT_PERS > 0 and nCOUNT_ERR = 0 then
    --       ,
    --        
    sFILENAME_SAVE  := UDOT_GET_FILENAME_BANKSPB(nCOMPANY, 'B', trunc(sysdate), sFILENAME);
    --     
    sMSG   := CR||CR||chr(9)||chr(9)||'  '||sFILENAME_SAVE||'  .';
    dbms_lob.writeappend(cCLOB, length(sMSG), sMSG);
    --       
    for rc_nls in (
    select value from nls_session_parameters
     where parameter = 'NLS_NUMERIC_CHARACTERS'
    ) loop
      execute immediate 'alter session set NLS_NUMERIC_CHARACTERS=''. ''';
      sMSG   := CR||CR||chr(9)||chr(9)||'     = '||trim(to_char(nSUMM_ALL,'9G999G999G999G990D00'))||CR;
      dbms_lob.writeappend(cCLOB, length(sMSG), sMSG);
      execute immediate 'alter session set NLS_NUMERIC_CHARACTERS='''||rc_nls.value||'''';
    end loop;
    --   dbf
    dbms_lob.createtemporary(bBLOB, true);
    if nSIGN_OLD_V = 0 then
      sTMP_C  := 'SBK_NUM,SBK_SUM,SBK_FIO,SBK_PAS,COMPANY,TABNOM,EDUCATION,CONTRACTNO,BIRTHDAY,CODE,FZ229_SUM';
    else
      sTMP_C  := 'SBK_NUM,SBK_SUM,SBK_FIO,SBK_PAS,COMPANY,TABNOM,CONTRACTNO,BIRTHDAY';
    end if;
    pkg_dbase.DUMP_TABLE_BLOB
    (
      sTABLE_NAME   => 'BANK_SPB_BFF_DBF'
     ,bDATA         => bBlob
     ,sCOLUMNS      => sTMP_C
     ,sWHERE_CLAUSE => ''
     ,nCONVERT      => 1  --  dbase-IV
    );
    --  
    update UDOT_SLREGTRN u
       set u.bdata    = bBLOB
          ,u.filename = sFILENAME_SAVE
     where u.rn = nRN;
    --        
    insert into file_buffer (rn, ident, authid, filename, bdata)
     values (gen_id, nPROCESS, user, sFILENAME_SAVE, bBLOB);
    --      
    sFILENAME_SAVE := regexp_replace(sFILENAME_SAVE,'(\.dbf)$','.log');
  elsif nCOUNT_PERS = 0 then
    --        
    select CR||CR||chr(9)||chr(9)||'   '||nvl2(T.DOC_PREF,trim(T.Doc_Pref)||'-'||trim(T.Doc_Numb),trim(T.Doc_Numb))||'  '||to_char(T.Doc_Date,'dd.mm.yyyy')||'    .'
      into sMSG
      from UDOT_SLREGTRN  T
     where T.RN = nRN;
    dbms_lob.writeappend(cCLOB, length(sMSG), sMSG);
  end if;

  --            
  insert into file_buffer (rn, ident, authid, filename, bdata)
   values (gen_id, nPROCESS, user, sFILENAME_SAVE, clob2blob(cCLOB));

  /*     */
  PKG_ENV.EPILOGUE( nCOMPANY,null,nCRN,nJUR_PERS,null,'UdotSalaryRegistersTransfers','UDOT_SLREGTRN_MAKE_DBF','UDOT_SLREGTRN',nRN );

end P_UDOT_SLREGTRN_MAKE_DBF;
/

grant execute on P_UDOT_SLREGTRN_MAKE_DBF to public;

spool off

