
spool c:\BSPb\Parus8\Addon\logs\__Add_Items_Menu.log


declare
  type tMenuItem is record
  (
    sItemCode    varchar2(40)
   ,sItemCaption varchar2(80)
   ,sItemMethod  varchar2(20)
   ,sIdent       varchar2(80)
   ,nSignExists  number(1)
  );
  type tMenuItems is table of tMenuItem index by varchar2(40);
  rMenuItem      tMenuItem;
  aMenuItems     tMenuItems;
  sSeparator     varchar2(240) := '<Separator Custom="-1"/>';
  sMenuItemPrev  varchar2(40)  := 'SalaryBudgetTransfers';
--  sMenuItemPrev  varchar2(40)  := 'PersonDevelopmentPlans';
  sMenuItem01    varchar2(40)  := 'UdotSalaryRegistersOpenAccounts';
  sMenuItem02    varchar2(40)  := 'UdotSalaryRegistersLoadAccounts';
  sMenuItem03    varchar2(40)  := 'UdotSalaryRegistersTransfers';
  nCondition     number(2) := -1;
  sMenuItem      varchar2(240);
  nSignExists    number(1) := 1;
--  sApplistCode   varchar2(40) := 'CivilServ';
  sApplistCode   varchar2(40) := 'BudgSlr';
  nRN_UserFormsAppMenu   number;
  nRN_Applist    number;
  sClobMenu      clob;
  sClobMenuAdd   clob;
  nCurrentPos    number;
  nLength        number;
  sCodeItem      varchar2(40);
begin
  --     
  select a.appcode
    into sApplistCode
    from applist a
   where a.appcode in ('BudgSlr','Salary');

  aMenuItems.delete();
  aMenuItems(sMenuItemPrev).nSignExists  := 0;
  aMenuItems(sMenuItemPrev).sItemCode    := sMenuItemPrev;
  sCodeItem  := sMenuItem01;
  aMenuItems(sCodeItem).nSignExists  := 0;
  aMenuItems(sCodeItem).sItemCode    := sCodeItem;
  aMenuItems(sCodeItem).sItemCaption := '    ';
  aMenuItems(sCodeItem).sItemMethod  := 'normal';
  sCodeItem  := sMenuItem02;
  aMenuItems(sCodeItem).nSignExists  := 0;
  aMenuItems(sCodeItem).sItemCode    := sCodeItem;
  aMenuItems(sCodeItem).sItemCaption := '   ';
  aMenuItems(sCodeItem).sItemMethod  := 'normal';
  sCodeItem  := sMenuItem03;
  aMenuItems(sCodeItem).nSignExists  := 0;
  aMenuItems(sCodeItem).sItemCode    := sCodeItem;
  aMenuItems(sCodeItem).sItemCaption := '   ';
  aMenuItems(sCodeItem).sItemMethod  := 'normal';
  --          ""
--  sMenuItem := '<MenuItem Code="'||sMenuItemCode||'" Method="'||sMethod||'" Conditions="'||nCondition||'" Caption="'||sCaption||'" Custom="-1"/>';
  --      
  for rc in (
  select scode
        ,scaption
        ,sident
        ,rn_usermenu
        ,appmenu
        ,rn_applist
    from (
          select xmltype(nvl(m.form_data,a.appmenu))  as para
                ,m.rn                                 as rn_usermenu
                ,nvl(m.form_data,a.appmenu)           as appmenu
                ,a.rn                                 as rn_applist
            from userformsapps m
                ,applist       a
           where a.appcode = sApplistCode --'BudgSlr'
             and a.rn  = m.prn(+)
         ) names
           ,xmltable('/MainMenu/Popup[@Group="Documents"]/MenuItem'
                     passing para
                     columns
                       scode       varchar2(40)  path '@Code'
                      ,scaption    varchar2(240) path '@Caption'
                      ,sident      varchar2(240) path '@Ident'
                    )
   where scode in (sMenuItemPrev,sMenuItem01,sMenuItem02,sMenuItem03)--sMenuItemCode)
--   where scode in ('SalaryBudgetTransfers','UdotSalaryRegistersTransfers','UdotSalaryRegistersOpenAccounts','UdotSalaryRegistersLoadAccounts','')
   order by scode
  ) loop
    if rc.scode = sMenuItemPrev then
      nRN_UserFormsAppMenu  := rc.rn_usermenu;
      sClobMenu             := rc.appmenu;
      nRN_Applist           := rc.rn_applist;
      aMenuItems(rc.scode).sIdent       := rc.sident;
      aMenuItems(rc.scode).nSignExists  := 1;
    else
      aMenuItems(rc.scode).nSignExists  := 1;
    end if;
  end loop;

  if aMenuItems(sMenuItemPrev).nSignExists = 1 then
    dbms_lob.createtemporary( sClobMenuAdd, true);
    nCurrentPos := dbms_lob.instr(sClobMenu, aMenuItems(sMenuItemPrev).sIdent, 1);
    nCurrentPos := dbms_lob.instr(sClobMenu, '/>', nCurrentPos);
    --    
    nCurrentPos := dbms_lob.instr(sClobMenu, substr(sSeparator,1,10), nCurrentPos);
    nCurrentPos := dbms_lob.instr(sClobMenu, '/>', nCurrentPos);
    dbms_lob.copy(sClobMenuAdd, sClobMenu, nCurrentPos + 1, 1, 1);
  else
    p_exception(0,'   "'||sApplistCode||'"    "'||sMenuItemPrev||'"');
  end if;
  if nRN_Applist is not null then
    sCodeItem  := aMenuItems.first;
    --    (    )
    sMenuItem  := '';
    for i in 1 .. aMenuItems.count
    loop
      if aMenuItems(sCodeItem).nSignExists = 0 then
        sMenuItem := '<MenuItem Code="'||aMenuItems(sCodeItem).sItemCode||'" Method="'||aMenuItems(sCodeItem).sItemMethod||'" Conditions="'||nCondition||'" Caption="'||aMenuItems(sCodeItem).sItemCaption||'" Custom="-1"/>';
        dbms_lob.writeappend(sClobMenuAdd, length(sMenuItem), sMenuItem);
      end if;
      sCodeItem := aMenuItems.next(sCodeItem);
    end loop;
    --  
    if sMenuItem is not null then
      dbms_lob.writeappend(sClobMenuAdd, length(sSeparator), sSeparator);
    end if;
    dbms_lob.copy(sClobMenuAdd, sClobMenu, dbms_lob.getlength(sClobMenu) - nCurrentPos - 1, dbms_lob.getlength(sClobMenuAdd) + 1, nCurrentPos + 2);
    --     
    if nRN_UserFormsAppMenu is null then
      insert into userformsapps
         (rn, prn, form_appcode, form_language, form_data)
       values
         (gen_id, nRN_Applist, sApplistCode, 'RUSSIAN', sClobMenuAdd);
    else
      update userformsapps u
         set u.form_data = sClobMenuAdd
       where u.rn = nRN_UserFormsAppMenu;
    end if;
--    insert into file_buffer(ident, authid, filename, data)
--      values (1001, user, 'NewAppMenu', sClobMenuAdd);
    dbms_lob.trim(sClobMenuAdd, 0);
    dbms_lob.trim(sClobMenu, 0);
  else
    p_exception(0,'');
  end if;
  dbms_output.put_line(aMenuItems.count);
end;
/

commit;

spool off

