
set echo on

spool c:\BSPb\Parus8\Addon\logs\__import_ExtraDictionaries.log


declare nRN_ED  number; nCRN number; nCOMPANY  number; nVERSION number;
  nRN_VAL number;
  sCOMPANY varchar2(20) := '';
  sUNITCODE varchar2(40) := 'ExtraDictionaries';
begin
  select C.RN into nCOMPANY from companies C where C.name = sCOMPANY;
  find_version_by_company_ex(0, nCOMPANY, sUNITCODE, nVERSION);
  find_acatalog_name_ex(0,0,null,nVERSION,sUNITCODE,' ',nCRN);
  nRN_ED := gen_id;
  insert into EXTRA_DICTS (RN, CRN, VERSION, CODE, NAME, FORMAT, NUM_WIDTH, NUM_PRECISION, STR_WIDTH)
      values (nRN_ED, nCRN, nVERSION, 'ISO_Codes_Country', 'ISO      -   ', 0, null, null, 2);
  nRN_VAL := gen_id;
  insert into EXTRA_DICTS_VALUES (RN, PRN, STR_VALUE, NUM_VALUE, DATE_VALUE, NOTE)
      values (nRN_VAL, nRN_ED, 'RU', null, null, ' ');
  nRN_VAL := gen_id;
  insert into EXTRA_DICTS_VALUES (RN, PRN, STR_VALUE, NUM_VALUE, DATE_VALUE, NOTE)
      values (nRN_VAL, nRN_ED, 'AZ', null, null, '');
  nRN_VAL := gen_id;
  insert into EXTRA_DICTS_VALUES (RN, PRN, STR_VALUE, NUM_VALUE, DATE_VALUE, NOTE)
      values (nRN_VAL, nRN_ED, 'AM', null, null, '');
  nRN_VAL := gen_id;
  insert into EXTRA_DICTS_VALUES (RN, PRN, STR_VALUE, NUM_VALUE, DATE_VALUE, NOTE)
      values (nRN_VAL, nRN_ED, 'BY', null, null, '');
  nRN_VAL := gen_id;
  insert into EXTRA_DICTS_VALUES (RN, PRN, STR_VALUE, NUM_VALUE, DATE_VALUE, NOTE)
      values (nRN_VAL, nRN_ED, 'EE', null, null, '');
  nRN_VAL := gen_id;
  insert into EXTRA_DICTS_VALUES (RN, PRN, STR_VALUE, NUM_VALUE, DATE_VALUE, NOTE)
      values (nRN_VAL, nRN_ED, 'GE', null, null, '');
  nRN_VAL := gen_id;
  insert into EXTRA_DICTS_VALUES (RN, PRN, STR_VALUE, NUM_VALUE, DATE_VALUE, NOTE)
      values (nRN_VAL, nRN_ED, 'KZ', null, null, '');
  nRN_VAL := gen_id;
  insert into EXTRA_DICTS_VALUES (RN, PRN, STR_VALUE, NUM_VALUE, DATE_VALUE, NOTE)
      values (nRN_VAL, nRN_ED, 'KG', null, null, '');
  nRN_VAL := gen_id;
  insert into EXTRA_DICTS_VALUES (RN, PRN, STR_VALUE, NUM_VALUE, DATE_VALUE, NOTE)
      values (nRN_VAL, nRN_ED, 'LV', null, null, '');
  nRN_VAL := gen_id;
  insert into EXTRA_DICTS_VALUES (RN, PRN, STR_VALUE, NUM_VALUE, DATE_VALUE, NOTE)
      values (nRN_VAL, nRN_ED, 'LT', null, null, '');
  nRN_VAL := gen_id;
  insert into EXTRA_DICTS_VALUES (RN, PRN, STR_VALUE, NUM_VALUE, DATE_VALUE, NOTE)
      values (nRN_VAL, nRN_ED, 'MD', null, null, '');
  nRN_VAL := gen_id;
  insert into EXTRA_DICTS_VALUES (RN, PRN, STR_VALUE, NUM_VALUE, DATE_VALUE, NOTE)
      values (nRN_VAL, nRN_ED, 'TJ', null, null, '');
  nRN_VAL := gen_id;
  insert into EXTRA_DICTS_VALUES (RN, PRN, STR_VALUE, NUM_VALUE, DATE_VALUE, NOTE)
      values (nRN_VAL, nRN_ED, 'TM', null, null, '');
  nRN_VAL := gen_id;
  insert into EXTRA_DICTS_VALUES (RN, PRN, STR_VALUE, NUM_VALUE, DATE_VALUE, NOTE)
      values (nRN_VAL, nRN_ED, 'UA', null, null, '');
  nRN_VAL := gen_id;
  insert into EXTRA_DICTS_VALUES (RN, PRN, STR_VALUE, NUM_VALUE, DATE_VALUE, NOTE)
      values (nRN_VAL, nRN_ED, 'UZ', null, null, '');
end;
/


commit;


spool off

set echo off
