
spool c:\BSPb\Parus8\Addon\logs\__create_objects_UdoSalaryRegistersLoadAccounts.log

create or replace function UDOT_GET_INFO_BANK_SPB return varchar2
as
begin
  return '  ,      ,        8:00  20:00 ( )

 :
 -  8(812)329-59-39
                      8(495)228-30-65
          8(4012)995-777
                   8(81368)96-070 . 59-39
                     8(800)500-59-39 

  : sbk@bspb.ru.
  <->
  :      "  ".

   
      
https://www.bspb.ru/business/distant-services/docs
';
end UDOT_GET_INFO_BANK_SPB;
/

grant execute on UDOT_GET_INFO_BANK_SPB to public;

/*      */
create table UDOT_SLREGLOADACC (
/*   */
RN number(17) not null,
/*    */
COMPANY number(17) not null,
/*    */
CRN number(17) not null,
/*     */
JUR_PERS number(17) not null,
/*    */
DATE_LOAD date not null,
/*    */
DATE_IMPORT date default null,
/*   dbf   */
BDATA blob not null,
/*   */
FILENAME varchar2(160) not null,
/*     */
BDATA_OUT blob default null,
/*     */
CDATA_REP clob default null,
/*   (0- , 1- ) */
REES_TYPE number(1) default 0 not null,
constraint C_UDOT_SLREGLOADACC_PK primary key (RN)  using index tablespace &INDX_B1709,
constraint C_UDOT_SLREGLOADACC_FILE_UK unique (COMPANY,FILENAME)  using index tablespace &INDX_B1709
)
LOB (BDATA) store as (tablespace &LOBS_B1709 NOCACHE LOGGING)
LOB (BDATA_OUT) store as (tablespace &LOBS_B1709 NOCACHE LOGGING)
LOB (CDATA_REP) store as (tablespace &LOBS_B1709 NOCACHE LOGGING);
-- Add comments to the table and to the columns
comment on table UDOT_SLREGLOADACC
  is '    ';
comment on column UDOT_SLREGLOADACC.RN
  is ' ';
comment on column UDOT_SLREGLOADACC.COMPANY
  is '  ';
comment on column UDOT_SLREGLOADACC.CRN
  is '  ';
comment on column UDOT_SLREGLOADACC.JUR_PERS
  is '   ';
comment on column UDOT_SLREGLOADACC.DATE_LOAD
  is '  ';
comment on column UDOT_SLREGLOADACC.DATE_IMPORT
  is '  ';
comment on column UDOT_SLREGLOADACC.BDATA
  is '  dbf  ';
comment on column UDOT_SLREGLOADACC.FILENAME
  is ' ';
comment on column UDOT_SLREGLOADACC.BDATA_OUT
  is '   ';
comment on column UDOT_SLREGLOADACC.CDATA_REP
  is '   ';
comment on column UDOT_SLREGLOADACC.REES_TYPE
  is '  (0- , 1- )';
-- Create foreign key constraints
alter table UDOT_SLREGLOADACC add (
constraint C_UDOT_SLREGLOADACC_JURPERS_FK foreign key (JUR_PERS)
  references JURPERSONS (RN),
constraint C_UDOT_SLREGLOADACC_CRN_FK foreign key (CRN)
  references ACATALOG (RN),
constraint C_UDOT_SLREGLOADACC_COMPANY_FK foreign key (COMPANY)
  references COMPANIES (RN)
);

create index I_UDOT_SLREGLOADACC_CRN_FK on UDOT_SLREGLOADACC(CRN) tablespace &INDX_B1709;

create index I_UDOT_SLREGLOADACC_JURPERS_FK on UDOT_SLREGLOADACC(JUR_PERS) tablespace &INDX_B1709;

create or replace trigger T_UDOT_SLREGLOADACC_BDELETE
  before delete on UDOT_SLREGLOADACC for each row
begin
  /*     dbf */
  if :old.date_import is not null then
    p_exception(0, '  .  .');
  end if;

  /*      */
  P_LINKSALL_CHECK( :old.RN,:old.COMPANY,'UdotSalaryRegistersLoadAccounts' );

  /*   */
  if ( PKG_IUD.PROLOGUE('UDOT_SLREGLOADACC', 'D') ) then
    PKG_IUD.REG_RN('RN', :old.RN);
    PKG_IUD.REG_COMPANY('COMPANY', :old.COMPANY);
    PKG_IUD.REG_CRN('CRN', :old.CRN);
    PKG_IUD.REG_JUR_PERS(1, 'JUR_PERS', :old.JUR_PERS, 'JURPERSONS', 'CODE');
    PKG_IUD.REG(2, 'FILENAME', :old.FILENAME);
    PKG_IUD.REG('DATE_LOAD',:old.DATE_LOAD );
    PKG_IUD.REG('DATE_IMPORT', :old.DATE_IMPORT);
    PKG_IUD.REG('REES_TYPE', :old.REES_TYPE);
    PKG_IUD.EPILOGUE;
  end if;
end T_UDOT_SLREGLOADACC_BDELETE;
/

create or replace procedure       P_UDOT_SLREGLOADACC_BASE_INS
(
  nCOMPANY                  in number,       -- 
  nCRN                      in number,       -- 
  nJUR_PERS                 in number,       -- 
  bBDATA                    in blob,         --   dbf
  sFILENAME                 in varchar2,     --  
  nREES_TYPE                in number,       --  
  nRN                       out number       --  
)
as
  nCOMPANY_CODES            number;
  sCOMPANY_CODES            varchar2(20);
  sCOMPANY_FILENAME         varchar2(160);
begin
  --      
  --        COMPANY
  if nREES_TYPE = 0 then
    --    ..  temporary
    pkg_dbase.LOAD_TABLE
    (
      bDATA       => bBDATA
     ,bFPT        => empty_blob
     ,sTABLE_NAME => case nrees_type when 0 then 'BANK_SPB_BFF_NEW_DBF' when 1 then 'BANK_SPB_ZCOMP_DBF' else '_______' end
     ,sEXCL_COLS  => ''
     ,nCONVERT    => 1   --   DBASE-IV
    );
    --     COMPANY
    begin
      select d.company
        into nCOMPANY_CODES
        from BANK_SPB_BFF_NEW_DBF  d
       group by d.company;
      --   
      sCOMPANY_CODES    := trim(to_char(nCOMPANY_CODES, '000000000'));
      sCOMPANY_CODES    := substr(sCOMPANY_CODES, 3, 2)||substr(sCOMPANY_CODES, 1, 2)||'_'||substr(sCOMPANY_CODES, 5);
      if sCOMPANY_CODES = '####_######' then
        sCOMPANY_FILENAME := 'Error_COMPANY_'||to_char(nCOMPANY_CODES)||'_'||sFILENAME;
      else
        sCOMPANY_FILENAME := regexp_replace(sFILENAME, '([[:digit:]]{4})_([[:digit:]]{5})', sCOMPANY_CODES);
      end if;

    exception
      when too_many_rows then
        p_exception(0,'     "COMPANY"   .   ,       .');
    end;

  else
    sCOMPANY_FILENAME := sFILENAME;
  end if;
  /*    */
  nRN := gen_id;

  /*     */
  insert into UDOT_SLREGLOADACC
  (
    RN,
    COMPANY,
    CRN,
    JUR_PERS,
    DATE_LOAD,
    BDATA,
    FILENAME,
    REES_TYPE
  )
  values
  (
    nRN,
    nCOMPANY,
    nCRN,
    nJUR_PERS,
    sysdate,
    bBDATA,
    sCOMPANY_FILENAME,
    nREES_TYPE
  );
end P_UDOT_SLREGLOADACC_BASE_INS;
/

create or replace trigger T_UDOT_SLREGLOADACC_BINSERT
  before insert on UDOT_SLREGLOADACC for each row
begin

  /*   */
  if ( PKG_IUD.PROLOGUE('UDOT_SLREGLOADACC', 'I') ) then
    PKG_IUD.REG_RN('RN', :new.RN);
    PKG_IUD.REG_COMPANY('COMPANY', :new.COMPANY);
    PKG_IUD.REG_CRN('CRN', :new.CRN);
    PKG_IUD.REG_JUR_PERS(1, 'JUR_PERS', :new.JUR_PERS, 'JURPERSONS', 'CODE');
    PKG_IUD.REG(2, 'FILENAME', :new.FILENAME);
    PKG_IUD.REG('DATE_LOAD',:new.DATE_LOAD );
    PKG_IUD.REG('DATE_IMPORT', :new.DATE_IMPORT);
    PKG_IUD.REG('REES_TYPE', :new.REES_TYPE);
    PKG_IUD.EPILOGUE;
  end if;
end T_UDOT_SLREGLOADACC_BINSERT;
/

create or replace trigger T_UDOT_SLREGLOADACC_BUPDATE
  before update on UDOT_SLREGLOADACC for each row
begin
  /*     */
  PKG_UNCHANGE.CHECK_NE('UDOT_SLREGLOADACC', 'RN', :new.RN, :old.RN);
  PKG_UNCHANGE.CHECK_NE('UDOT_SLREGLOADACC', 'COMPANY', :new.COMPANY, :old.COMPANY);
  PKG_UNCHANGE.CHECK_NE('UDOT_SLREGLOADACC', 'JUR_PERS', :new.JUR_PERS, :old.JUR_PERS);
  PKG_UNCHANGE.CHECK_NE('UDOT_SLREGLOADACC', 'FILENAME', :new.FILENAME, :old.FILENAME);
  PKG_UNCHANGE.CHECK_NE('UDOT_SLREGLOADACC', 'DATE_LOAD', :new.DATE_LOAD, :old.DATE_LOAD);
  PKG_UNCHANGE.CHECK_NE('UDOT_SLREGLOADACC', 'REES_TYPE', :new.REES_TYPE, :old.REES_TYPE);

  /*       */
  if ( CMP_NUM(:new.CRN,:old.CRN) = 1 ) then
    /*     dbf */
    if :old.date_import is not null and :new.date_import is not null then
      p_exception(0, '  .  .');
    end if;
  end if;

  /*   */
  if ( PKG_IUD.PROLOGUE('UDOT_SLREGLOADACC', 'U') ) then
    PKG_IUD.REG_RN('RN', :new.RN, :old.RN);
    PKG_IUD.REG_COMPANY('COMPANY', :new.COMPANY, :old.COMPANY);
    PKG_IUD.REG_CRN('CRN', :new.CRN, :old.CRN);
    PKG_IUD.REG_JUR_PERS(1, 'JUR_PERS', :new.JUR_PERS, :old.JUR_PERS, 'JURPERSONS', 'CODE');
    PKG_IUD.REG(2, 'FILENAME', :new.FILENAME, :old.FILENAME);
    PKG_IUD.REG('DATE_LOAD', :new.DATE_LOAD, :old.DATE_LOAD );
    PKG_IUD.REG('DATE_IMPORT', :new.DATE_IMPORT, :old.DATE_IMPORT);
    PKG_IUD.REG('REES_TYPE', :new.REES_TYPE, :old.REES_TYPE);
    PKG_IUD.EPILOGUE;
  end if;
end T_UDOT_SLREGLOADACC_BUPDATE;
/

create or replace trigger T_UDOT_SLREGLOADACC_ADELETE
  after delete on UDOT_SLREGLOADACC for each row
begin
  /*       */
  P_LOG_DELETE( :old.RN,'UdotSalaryRegistersLoadAccounts' );
end T_UDOT_SLREGLOADACC_ADELETE;
/

create or replace procedure P_UDOT_SLREGLOADACC_BASE_DEL
(
  nCOMPANY                  in number        -- 
 ,nRN                       in number        --  
)
as
begin
  /*     */
  delete
    from UDOT_SLREGLOADACC
   where RN = nRN
     and COMPANY = nCOMPANY;

  if (SQL%NOTFOUND) then
    PKG_MSG.RECORD_NOT_FOUND( nRN,'UdotSalaryRegistersLoadAccounts' );
  end if;
end P_UDOT_SLREGLOADACC_BASE_DEL;
/

create or replace procedure P_UDOT_SLREGLOADACC_EXISTS
(
  nRN                       in number,       --  
  nCOMPANY                  in number,       -- 
  nCRN                      out number,      -- 
  nJUR_PERS                 out number,      -- 
  dDATE_IMPORT              out date         --  
)
as
begin
  /*   */
  begin
    select M.CRN, M.JUR_PERS, M.DATE_IMPORT
      into nCRN,nJUR_PERS, dDATE_IMPORT
      from UDOT_SLREGLOADACC  M
     where M.RN = nRN
       and M.COMPANY = nCOMPANY;
  exception
    when NO_DATA_FOUND then
      PKG_MSG.RECORD_NOT_FOUND( nRN,'UdotSalaryRegistersLoadAccounts' );
  end;
end P_UDOT_SLREGLOADACC_EXISTS;
/

grant execute on P_UDOT_SLREGLOADACC_EXISTS to public;

create or replace trigger T_UDOT_SLREGLOADACC_AUPDATE
  after update on UDOT_SLREGLOADACC for each row
begin
  /*       */
  P_LOG_UPDATE( :new.RN,'UdotSalaryRegistersLoadAccounts',:new.CRN,:old.CRN,:new.JUR_PERS,:old.JUR_PERS );
end;
/

/* V_UDOT_SLREGLOADACC */
create or replace view V_UDOT_SLREGLOADACC (
  NRN,
  NCOMPANY,
  NCRN,
  NJUR_PERS,
  SJUR_PERS,
  NAGENT,
  SAGENT,
  DDATE_LOAD,
  DDATE_IMPORT,
  SFILENAME,
  NREES_TYPE
) as
select
  T.RN                       -- nRN
 ,T.COMPANY                  -- nCOMPANY
 ,T.CRN                      -- nCRN
 ,T.JUR_PERS                 -- nJUR_PERS
 ,J.CODE                     -- sJUR_PERS
 ,J.AGENT                    -- nAGENT
 ,AJ.AGNABBR                 -- sAGENT
 ,T.DATE_LOAD                -- dDATE_LOAD
 ,T.DATE_IMPORT              -- dDATE_IMPORT
 ,T.FILENAME                 -- sFILENAME
 ,T.REES_TYPE                -- nREES_TYPE
from
  UDOT_SLREGLOADACC  T
 ,JURPERSONS         J
 ,AGNLIST            AJ
where T.JUR_PERS = J.RN
  and J.AGENT = AJ.RN
  and exists (select null from V_USERPRIV UP where UP.CATALOG = T.CRN)
  and exists (select null from V_USERPRIV UP where UP.JUR_PERS = T.JUR_PERS and UP.UNITCODE = 'UdotSalaryRegistersLoadAccounts')
;

grant select on V_UDOT_SLREGLOADACC to public;

create or replace procedure P_UDOT_SLREGLOADACC_DELETE
(
  nCOMPANY                  in number       -- 
 ,nRN                       in number       --  
)
as
  nCRN                      PKG_STD.tREF;    -- 
  nJUR_PERS                 PKG_STD.tREF;    -- 
  dDATE_IMPORT              date;            --  
begin
  /*    */
  P_UDOT_SLREGLOADACC_EXISTS
  (
    nRN            => nRN           --  
   ,nCOMPANY       => nCOMPANY      -- 
   ,nCRN           => nCRN          -- 
   ,nJUR_PERS      => nJUR_PERS     -- 
   ,dDATE_IMPORT   => dDATE_IMPORT  --  
  );

  if dDATE_IMPORT is not null then
    p_exception(0, '  .  . ');
  end if;

  /*     */
  PKG_ENV.PROLOGUE( nCOMPANY,null,nCRN,nJUR_PERS,null,'UdotSalaryRegistersLoadAccounts','UDOT_SLREGLOADACC_DELETE','UDOT_SLREGLOADACC',nRN );

  /*   */
  P_UDOT_SLREGLOADACC_BASE_DEL
  (
    nCOMPANY    => nCOMPANY    -- 
   ,nRN         => nRN         --  
  );

  /*     */
  PKG_ENV.EPILOGUE( nCOMPANY,null,nCRN,nJUR_PERS,null,'UdotSalaryRegistersLoadAccounts','UDOT_SLREGLOADACC_DELETE','UDOT_SLREGLOADACC',nRN );
end P_UDOT_SLREGLOADACC_DELETE;
/

grant execute on P_UDOT_SLREGLOADACC_DELETE to public;

create or replace procedure P_UDOT_SLREGLOADACC_MOVE
(
  nCOMPANY      in number,
  nRN           in number,
  nCRN          in number
)
as
  nCRN1         PKG_STD.tREF;
  nJUR_PERS     PKG_STD.tREF;
  dDATE_IMPORT  date;
begin
  /*   */
  P_UDOT_SLREGLOADACC_EXISTS ( nCOMPANY, nRN, nCRN1, nJUR_PERS, dDATE_IMPORT);

  /*     */
  PKG_ENV.PROLOGUE( nCOMPANY, null, nCRN1, nJUR_PERS, 'UdotSalaryRegistersLoadAccounts', 'UDOT_SLREGLOADACC_MOVE_OUT', 'UDOT_SLREGLOADACC', nRN );
  PKG_ENV.PROLOGUE( nCOMPANY, null, nCRN, nJUR_PERS,  'UdotSalaryRegistersLoadAccounts', 'UDOT_SLREGLOADACC_MOVE_IN',  'UDOT_SLREGLOADACC', nRN );

  /*   */
  update UDOT_SLREGLOADACC
     set CRN = nCRN
    where RN = nRN
      and COMPANY = nCOMPANY;

  if ( SQL%NOTFOUND ) then
    PKG_MSG.RECORD_NOT_FOUND( nRN,'UdotSalaryRegistersLoadAccounts' );
  end if;

  /*     */
  PKG_ENV.EPILOGUE( nCOMPANY, null, nCRN1, nJUR_PERS, 'UdotSalaryRegistersLoadAccounts', 'UDOT_SLREGLOADACC_MOVE_OUT', 'UDOT_SLREGLOADACC', nRN );
  PKG_ENV.EPILOGUE( nCOMPANY, null, nCRN, nJUR_PERS,  'UdotSalaryRegistersLoadAccounts', 'UDOT_SLREGLOADACC_MOVE_IN',  'UDOT_SLREGLOADACC', nRN );
end P_UDOT_SLREGLOADACC_MOVE;
/

grant execute on P_UDOT_SLREGLOADACC_MOVE to public;

create or replace procedure             P_UDOT_SLREGLOADACC_IMPORT
(
  nCOMPANY        in number     -- 
 ,nRN             in number     --  
 ,sDOP_ORG        in varchar2   --     
 ,sAGNBANKS       in varchar2   --    
 ,nSIGN_SET_CARD  in number     --     
 ,nPROCESS        in number     --  
)
as
  nCRN                      PKG_STD.tREF;    -- 
  nJUR_PERS                 PKG_STD.tREF;    -- 
  nDOCS_PROPS_ORG           pkg_std.tref;
  nAGNBANKS                 pkg_std.tref;
  sPERS_OWNER               agnlist.agnabbr%type;
  dDATE_IMPORT              date;            --  
  bBLOB                     blob;   --    dbf
  cCLOB                     clob;   --   
  sMSG_LINE                 varchar2(4000);
  sCOMPANY_CODES            varchar2(20);
  sCOMPANY_FILE             varchar2(20);
  nTMP                      number;
  sTMP                      varchar2(4000);
  nSIGN_SEEK                number;
  sAGNNAMEACC               agnacc.agnnameacc%type;
  sSTRCODE                  agnacc.strcode%type;
  nAGNACC                   pkg_std.tref;
begin
  /*    */
  P_UDOT_SLREGLOADACC_EXISTS
  (
    nRN            => nRN           --  
   ,nCOMPANY       => nCOMPANY      -- 
   ,nCRN           => nCRN          -- 
   ,nJUR_PERS      => nJUR_PERS     -- 
   ,dDATE_IMPORT   => dDATE_IMPORT  --  
  );
  if dDATE_IMPORT is not null then
    p_exception(0, '   .   .');
  end if;

  --   .  
  find_docs_props_code(0, nCOMPANY, sDOP_ORG, nDOCS_PROPS_ORG);
  --  
  find_agnbanks_agent( 0, nCOMPANY, sAGNBANKS, nAGNBANKS);
  --   
  select a.agnabbr
    into sPERS_OWNER
    from jurpersons j
        ,agnlist    a
   where j.rn = nJUR_PERS
     and j.agent = a.rn;

  /*     */
  PKG_ENV.PROLOGUE( nCOMPANY,null,nCRN,nJUR_PERS,null,'UdotSalaryRegistersLoadAccounts','UDOT_SLREGLOADACC_IMPORT','UDOT_SLREGLOADACC',nRN );

  --            
  --        
  begin
    select (select dv.str_value from DOCS_PROPS_VALS dv
             where dv.unitcode = 'AGNLIST' and dv.unit_rn = j.agent
               and dv.docs_prop_rn = nDOCS_PROPS_ORG--200824720
           )         as  sCOMPANY
      into sCOMPANY_CODES
      from jurpersons j
     where j.rn = nJUR_PERS;
    if trim(sCOMPANY_CODES) is null then
      p_exception(0, '       "    "     .');
    end if;
  exception
    when NO_DATA_FOUND then
      p_exception(0, '        "    "    .');
  end;
  --     
  sCOMPANY_FILE   := substr(sCOMPANY_CODES, 3, 2)||substr(sCOMPANY_CODES, 1, 2)||'_'||substr(sCOMPANY_CODES, 5);

  for rc in (
  select m.filename, m.bdata, m.rees_type, m.rn
    from UDOT_SLREGLOADACC  m
   where m.rn = nRN
  ) loop
    dbms_lob.createtemporary(bBLOB, true, dbms_lob.call);
    dbms_lob.createtemporary(cCLOB, true, dbms_lob.call);
    if not rc.rees_type in (0,1) then
      p_exception(0,'     -  ');
    elsif rc.rees_type = 0 then
      if regexp_replace(upper(rc.filename),'^(B)([[:digit:]]{4})(_)([[:digit:]]{5})(\.)([[:digit:]]*)(\.)([DBF]{3})$') is not null then
        p_exception(0,'      ('||rc.filename||'), .. "BFFff_XXXXX.DDN.dbf" -  ');
      elsif substr(rc.filename,2,length(sCOMPANY_FILE)) <> sCOMPANY_FILE then
        p_exception(0,'                ('||rc.filename||') <--> ('||sCOMPANY_FILE||') -  ');
      end if;
    elsif rc.rees_type = 1 then
      if regexp_replace(upper(rc.filename),'^(Z)([[:digit:]]{9})(\.)([[:digit:]]*)(\.)([DBF]{3})$') is not null then
        p_exception(0,'      ('||rc.filename||'), .. "ZffFFXXXXX.DDN.dbf" -  ');
      elsif substr(rc.filename,2,length(sCOMPANY_CODES)) <> sCOMPANY_CODES then
        p_exception(0,'                ('||rc.filename||') <--> ('||sCOMPANY_CODES||') -  ');
      end if;
    end if;

    pkg_dbase.LOAD_TABLE
    (
      bDATA       => rc.bdata
     ,bFPT        => empty_blob
     ,sTABLE_NAME => case rc.rees_type when 0 then 'BANK_SPB_BFF_NEW_DBF' when 1 then 'BANK_SPB_ZCOMP_DBF' else '_______' end
     ,sEXCL_COLS  => ''
     ,nCONVERT    => 1   --   DBASE-IV
    );
    if rc.rees_type = 0 then
      --   ,      ( .. = 0)
      select nvl(max(d.sbk_sum),0)||nvl(min(d.sbk_sum),0)
        into sTMP
        from BANK_SPB_BFF_NEW_DBF d;
      if sTMP <> '00' then
        p_exception(0,' '||rc.filename||'    ""   .       -  .');
      end if;
      for rc_i in (
      select *
        from BANK_SPB_BFF_NEW_DBF
      ) loop
        --            
        if sCOMPANY_CODES <> rc_i.company then
          SMSG_LINE  := ':     "COMPANY" ('||rc_i.company||')     "'||rc_i.sbk_fio||'"        ('||sCOMPANY_CODES||')';
        else
          --     ( .),    
          nSIGN_SEEK  := 0;
          sMSG_LINE   := '';
          sSTRCODE    := '';
          for rc_a in (
          select p.pers_agent, p.rn  as pers_rn
                ,count(1) over ()                           as nCOUNT_ALL
                ,count(1) over (partition by p.pers_agent)  as nCOUNT_AGENT
                ,count(1) over (partition by p.rn)          as nCOUNT_PERS
            from jurpersons    j
                ,clnpersons    p
                ,agnlist       a
                ,agndocums     d
           where j.rn = nJUR_PERS
             and p.owner_agent = j.agent
             and p.pers_agent = a.rn
             and d.prn = p.pers_agent
             and p.dismiss_date is null
--             and d.default_sign = 1
             and upper(a.agnfamilyname||' '||a.agnfirstname||' '||a.agnlastname) = upper(rc_i.sbk_fio)
             and d.docser||' '||d.docnumb = rc_i.sbk_pas
          ) loop
            nSIGN_SEEK := nSIGN_SEEK + 1;
            if rc_a.ncount_agent <> rc_a.ncount_all then
              sMSG_LINE  := ':   (  "'||sPERS_OWNER||'")    (    ),     ('||to_char(sysdate,'dd.mm.yyyy')||'), c :  - "'||rc_i.sbk_fio||'",   - "'||rc_i.sbk_pas||'".    .';
              exit;
            else    --if rc_a.ncount_pers <> rc_a.ncount_agent then
              -- ..  1    
              if nSIGN_SEEK = 1 then
                --        
                --     ,    
                begin
                  select RN
                    into nAGNACC
                    from AGNACC   G
                   where G.AGNRN    = rc_a.pers_agent
                     and G.Agnacc   = rc_i.sbk_num
                     and G.Agnbanks = nAGNBANKS
                     and rownum   = 1;
                exception
                  when NO_DATA_FOUND then
                    nAGNACC  := null;
                end;
                if nAGNACC is null then
                  begin
                    p_agnacc_create_strcode
                    (
                      nCOMPANY    => nCOMPANY
                     ,nPRN        => rc_a.pers_agent
                     ,sAGENT_CODE => ''
                     ,sAGNNAMEACC => sAGNNAMEACC
                     ,sSTRCODE    => sSTRCODE
                    );
                  exception
                    when others then
                      p_exception(0, '               "'||rc_i.sbk_fio||'",  "'||rc_i.sbk_pas||'".'||CR||sqlerrm);
                  end;
                  UDOT_P_AGNACC_INSERT
                  (
                    nCOMPANY       => nCOMPANY
                   ,nPRN           => rc_a.pers_agent
                   ,sSTRCODE       => sSTRCODE
                   ,sAGNACC        => rc_i.sbk_num
                   ,sAGNNAMEACC    => sAGNNAMEACC
                   ,sAGNBANKS      => sAGNBANKS
                   ,dOPEN_DATE     => trunc(sysdate,'MM')
                   ,nRN            => nAGNACC
                  );
                  sMSG_LINE  := ':      :  - "'||rc_i.sbk_fio||'",   - "'||rc_i.sbk_pas||'".';
                else
                  --    
                  --      
                  update AGNACC uc
                     set uc.close_date  = null
                        ,uc.access_flag = 1
                   where uc.rn = nAGNACC;
                  sMSG_LINE  := ':      :  - "'||rc_i.sbk_fio||'",   - "'||rc_i.sbk_pas||'".';
                end if;
                if rc_a.ncount_pers <> rc_a.ncount_agent then
                  sMSG_LINE  := sMSG_LINE||CR||'  :   (  "'||sPERS_OWNER||'")    (  ),     ('||to_char(sysdate,'dd.mm.yyyy')||'), c :  - "'||rc_i.sbk_fio||'",   - "'||rc_i.sbk_pas||'". ';
                end if;
              end if;
              if nSIGN_SET_CARD = 1 then
                --    
                --  
                --  )     
                --  )    
                update clnpersons u
                   set u.trn_agent_acc = nAGNACC
                      ,u.trn_agent     = rc_a.pers_agent
                 where u.rn = rc_a.pers_rn
                   and (u.trn_agent = rc_a.pers_agent
                        or u.trn_agent is null
                       );
                sMSG_LINE  := sMSG_LINE||CR||'  :       .';
              end if;
            end if;
          end loop;
          if nSIGN_SEEK = 0 then
            sMSG_LINE  := ':   (  "'||sPERS_OWNER||'")   ,     ('||to_char(sysdate,'dd.mm.yyyy')||'), c :  - "'||rc_i.sbk_fio||'",   - "'||rc_i.sbk_pas||'".';
          elsif sMSG_LINE is null then
            sMSG_LINE  := ':      :  - "'||rc_i.sbk_fio||'",   - "'||rc_i.sbk_pas||'".';
          end if;
        end if;
        sMSG_LINE := sMSG_LINE||CR||CR;
        dbms_lob.writeappend(cCLOB, length(sMSG_LINE), sMSG_LINE);
      end loop;
    elsif rc.rees_type = 1 then
      for rc_r in (
      select z.rowid as z_rowid, rownum  as nnumb, z.*
        from BANK_SPB_ZCOMP_DBF z
      ) loop
        --     ( .),    
        nSIGN_SEEK  := 0;
        sMSG_LINE   := '';
        sSTRCODE    := '';
        for rc_a in (
        select p.pers_agent, p.rn  as pers_rn
              ,count(1) over ()                           as nCOUNT_ALL
              ,count(1) over (partition by p.pers_agent)  as nCOUNT_AGENT
              ,count(1) over (partition by p.rn)          as nCOUNT_PERS
          from jurpersons    j
              ,clnpersons    p
              ,agnlist       a
              ,agndocums     d
         where j.rn = nJUR_PERS
           and p.owner_agent = j.agent
           and p.pers_agent = a.rn
           and d.prn = p.pers_agent
           and p.dismiss_date is null
--           and d.default_sign = 1
           and upper(a.agnfamilyname||' '||a.agnfirstname||' '||a.agnlastname) = upper(rc_r.fio)
           and d.docser||' '||d.docnumb = rc_r.pasnom
        ) loop
          nSIGN_SEEK := nSIGN_SEEK + 1;
          begin
            select RN
              into nAGNACC
              from AGNACC   G
             where G.AGNRN    = rc_a.pers_agent
               and G.Agnacc   = rc_r.account
               and G.Agnbanks = nAGNBANKS
               and rownum   = 1;
          exception
            when NO_DATA_FOUND then
              nAGNACC  := null;
          end;
          if nAGNACC is null then
            sMSG_LINE  := ':   :  - "'||rc_r.fio||'",   - "'||rc_r.pasnom||'"    (  "'||sPERS_OWNER||'")    ('||to_char(sysdate,'dd.mm.yyyy')||'),        - "'||rc_r.account||'".';
            delete from BANK_SPB_ZCOMP_DBF d
              where d.rowid = rc_r.z_rowid;
          else
            sMSG_LINE  := ':   :  - "'||rc_r.fio||'",   - "'||rc_r.pasnom||'"    (  "'||sPERS_OWNER||'")    ('||to_char(sysdate,'dd.mm.yyyy')||').';
          end if;
        end loop;
        if nSIGN_SEEK = 0 then
          sMSG_LINE  := ':  c :  - "'||rc_r.fio||'",   - "'||rc_r.pasnom||'"     (  "'||sPERS_OWNER||'")    ('||to_char(sysdate,'dd.mm.yyyy')||').';
          delete from BANK_SPB_ZCOMP_DBF d
            where d.rowid = rc_r.z_rowid;
        end if;
--        sMSG_LINE  := rc_r.pan||','||rc_r.fio||','||rc_r.pasnom||','||rc_r.account||CR;
        sMSG_LINE := sMSG_LINE||CR||CR;
        dbms_lob.writeappend(cCLOB, length(sMSG_LINE), sMSG_LINE);
      end loop;
      --    
      pkg_dbase.DUMP_TABLE_BLOB
      (
        sTABLE_NAME   => 'BANK_SPB_ZCOMP_DBF'
       ,bDATA         => bBlob
       ,sCOLUMNS      => 'PAN,FIO,PASNOM,ACCOUNT'
       ,sWHERE_CLAUSE => ''
       ,nCONVERT      => 1  --  dbase-IV
      );
      insert into file_buffer ( ident, authid, filename, bdata)
       values ( nPROCESS, user, rc.filename, bBLOB);
    end if;
    --    
    insert into file_buffer ( ident, authid, filename, data)
     values ( nPROCESS, user, replace(upper(rc.filename),'.DBF','.log'), cCLOB);

    --         
    update UDOT_SLREGLOADACC  m
       set m.date_import = sysdate
          ,m.cdata_rep   = cCLOB
          ,m.bdata_out   = case when nvl(dbms_lob.getlength(bBLOB),0) > 0 then bBLOB else empty_blob end
     where m.rn = nRN;

    dbms_lob.trim(bBLOB, 0);
    dbms_lob.trim(cCLOB, 0);

  end loop;

  /*     */
  PKG_ENV.EPILOGUE( nCOMPANY,null,nCRN,nJUR_PERS,null,'UdotSalaryRegistersLoadAccounts','UDOT_SLREGLOADACC_IMPORT','UDOT_SLREGLOADACC',nRN );
end P_UDOT_SLREGLOADACC_IMPORT;
/

grant execute on P_UDOT_SLREGLOADACC_IMPORT to public;

create or replace procedure P_UDOT_SLREGLOADACC_REMOVE
(
  nCOMPANY                  in number       -- 
 ,nRN                       in number       --  
)
as
  nCRN                      PKG_STD.tREF;    -- 
  nJUR_PERS                 PKG_STD.tREF;    -- 
  dDATE_IMPORT              date;            --  
begin
  /*    */
  P_UDOT_SLREGLOADACC_EXISTS
  (
    nRN            => nRN           --  
   ,nCOMPANY       => nCOMPANY      -- 
   ,nCRN           => nCRN          -- 
   ,nJUR_PERS      => nJUR_PERS     -- 
   ,dDATE_IMPORT   => dDATE_IMPORT  --  
  );

  if dDATE_IMPORT is null then
    p_exception(0, '    .   . ');
  end if;

  /*     */
  PKG_ENV.PROLOGUE( nCOMPANY,null,nCRN,nJUR_PERS,null,'UdotSalaryRegistersLoadAccounts','UDOT_SLREGLOADACC_REMOVE','UDOT_SLREGLOADACC',nRN );

  /*   */
  update UDOT_SLREGLOADACC U
     set U.Date_Import = null
        ,U.Bdata_Out   = empty_blob
        ,U.Cdata_Rep   = empty_clob
   where U.RN = nRN;

  /*     */
  PKG_ENV.EPILOGUE( nCOMPANY,null,nCRN,nJUR_PERS,null,'UdotSalaryRegistersLoadAccounts','UDOT_SLREGLOADACC_REMOVE','UDOT_SLREGLOADACC',nRN );
end P_UDOT_SLREGLOADACC_REMOVE;
/

grant execute on P_UDOT_SLREGLOADACC_REMOVE to public;

create or replace procedure P_UDOT_SLREGLOADACC_INSERT
(
  nCOMPANY                  in number        -- 
 ,nCRN                      in number        -- 
 ,sJUR_PERS                 in varchar2      --  ()
 ,bBDATA                    in blob          --   dbf
 ,sFILENAME                 in varchar2      --  
 ,nREES_TYPE                in number        --    (0- , 1- )
 ,nRN                       out number       --  
)
as
  nJUR_PERS                 PKG_STD.tREF;    -- 
begin
  /*   */
  find_jurpersons_code(0, 0, nCOMPANY, sJUR_PERS, nJUR_PERS);

  /*     */
  PKG_ENV.PROLOGUE( nCOMPANY,null,nCRN,nJUR_PERS,null,'UdotSalaryRegistersLoadAccounts','UDOT_SLREGLOADACC_INSERT','UDOT_SLREGLOADACC' );

  /*   */
  P_UDOT_SLREGLOADACC_BASE_INS
  (
    nCOMPANY    => nCOMPANY    -- 
   ,nCRN        => nCRN        -- 
   ,nJUR_PERS   => nJUR_PERS   -- 
   ,bBDATA      => bBDATA      --   dbf
   ,sFILENAME   => regexp_substr(sFILENAME,'([^\]*$)')   --    
   ,nREES_TYPE  => nREES_TYPE  --  
   ,nRN         => nRN         --  
  );

  /*     */
  PKG_ENV.EPILOGUE( nCOMPANY,null,nCRN,nJUR_PERS,null,'UdotSalaryRegistersLoadAccounts','UDOT_SLREGLOADACC_INSERT','UDOT_SLREGLOADACC',nRN );
end P_UDOT_SLREGLOADACC_INSERT;
/

grant execute on P_UDOT_SLREGLOADACC_INSERT to public;

create or replace procedure P_UDOT_SLREGLOADACC_LOAD
(
  nCOMPANY                  in number,       -- 
  nCRN                      in number,       -- 
  nIDENT                    in number,       --  
  nREES_TYPE                in number,       --    (0- , 1- )
  sJUR_PERS                 in varchar2      --  ()
)
as
  nJUR_PERS                 PKG_STD.tREF;    -- 
  nRN                       pkg_std.tref;
  bBLOB_TMP                 blob;
begin
  /*   */
  find_jurpersons_code(0, 0, nCOMPANY, sJUR_PERS, nJUR_PERS);

  /*       */
  PKG_ENV.ACCESS( nCOMPANY,null,nCRN,nJUR_PERS,'UdotSalaryRegistersLoadAccounts','UDOT_SLREGLOADACC_LOAD');

  dbms_lob.createtemporary(bBLOB_TMP, true, dbms_lob.call);
  for rc in (
  select f.filename, f.data, f.bdata
    from file_buffer   f
   where f.ident = nIDENT
  ) loop
    dbms_lob.trim(bBLOB_TMP, 0);
    if nvl(dbms_lob.getlength(rc.bdata),0) = 0 then
      bBLOB_TMP := clob2blob(rc.data);
    else
      bBLOB_TMP := rc.bdata;
    end if;
    /*   */
    P_UDOT_SLREGLOADACC_INSERT
    (
      nCOMPANY    => nCOMPANY    -- 
     ,nCRN        => nCRN        -- 
     ,sJUR_PERS   => sJUR_PERS   -- 
     ,bBDATA      => bBLOB_TMP   --   dbf
     ,sFILENAME   => rc.filename --  
     ,nREES_TYPE  => nREES_TYPE  --  
     ,nRN         => nRN         --  
    );
  end loop;

end P_UDOT_SLREGLOADACC_LOAD;
/

grant execute on P_UDOT_SLREGLOADACC_LOAD to public;

spool off

