
spool c:\BSPb\Parus8\Addon\logs\__create_objects_UdoSalaryRegistersOpenAccountsPersons.log

create or replace procedure P_UDOT_SLREGOPACCPR_FORM_EDIT
(
  SATTRIB              in varchar2,     --  
  NFIRST               in out number,   --  
  NCOMPANY             in number,       -- 
  NIS_UNLOAD           in out number,
  SGEOGRNAME           in out varchar2, --  
  SDOC_CODE            in out varchar2, --    (PERS)
  SRF_CODE             in out varchar2, --    (RF)
  SDOC_SER             in out varchar2,
  SDOC_NUMB            in out varchar2,
  SRF_SER              in out varchar2,
  SRF_NUMB             in out varchar2,
  NCURNAMES            in out number,
  NBANKPRG             in out number,
  NBANKACCTYPES        in out number,
  RESIDENT_SIGN        in out number,
  SCURNAMES            in out varchar2, -- 
  NSCURNAMES_ENAB      in out number,   --  - 
  NRESIDENT_SIGN       in out number,   -- 
  NNRESIDENT_SIGN_ENAB in out number,   --  - 
  SBANKPRG             in out varchar2, --  
  NSBANKPRG_ENAB       in out number,   --   - 
  SBANKACCTYPES        in out varchar2, --   ( )
  NSBANKACCTYPES_ENAB  in out number,   --   ( ) - 
  SAGNFAMILYNAME       in out varchar2, -- 
  NSAGNFAMILYNAME_ENAB in out number,   --  - 
  SAGNFIRSTNAME        in out varchar2, -- 
  NSAGNFIRSTNAME_ENAB  in out number,   --  - 
  SAGNLASTNAME         in out varchar2, -- 
  NSAGNLASTNAME_ENAB   in out number,   --  - 
  DAGENT_BORN          in out date,     --  
  NDAGENT_BORN_ENAB    in out number,   --   - 
  AGENT_SEX            in out number,   -- 
  NAGENT_SEX_ENAB      in out number,   --  - 
  SAGENT_PHONE         in out varchar2, --  1
  NSAGENT_PHONE_ENAB   in out number,   --  1 - 
  SAGENT_PHONE2        in out varchar2, --  2
  NSAGENT_PHONE2_ENAB  in out number,   --  2 - 
  SAGENT_MAIL          in out varchar2, --  
  NSAGENT_MAIL_ENAB    in out number,   --   - 
  SGEOGRFULLNAME       in out varchar2, -- 
  NSGEOGRFULLNAME_ENAB in out number,   --  - 
  SADDR_HOUSE          in out varchar2, -- 
  NSADDR_HOUSE_ENAB    in out number,   --  - 
  SADDR_BLOCK          in out varchar2, -- 
  NSADDR_BLOCK_ENAB    in out number,   --  - 
  SADDR_BUILDING       in out varchar2, -- 
  NSADDR_BUILDING_ENAB in out number,   --  - 
  SADDR_FLAT           in out varchar2, -- 
  NSADDR_FLAT_ENAB     in out number,   --  - 
  SADDR_POST           in out varchar2, --  
  NSADDR_POST_ENAB     in out number,   --   - 
  SCITIZENSHIP         in out varchar2, -- 
  NSCITIZENSHIP_ENAB   in out number,   --  - 
  NSGEOGRNAME_ENAB     in out number,
  NSDOC_CODE_ENAB      in out number,
  NSRF_CODE_ENAB       in out number,
  NSEMBOSS_ENAB        in out number,   --   - 
  NSCONTROL_INF_ENAB   in out number,   --   - 
  NNRECIEVE_TYPE_ENAB  in out number,   --   - 
  NNRECIEVE_CARD_ENAB  in out number,   --   - 
  NNINCOME_ENAB        in out number,   --   - 
  NDJOBBEGIN_ENAB      in out number,   --     - 
  NSSMS_COUNTRY_ENAB   in out number,   --   - 
  NSSMS_PHONE_ENAB     in out number    --   - 
)
as

  procedure AGNADDRESSESClear
  as
  begin
    SGEOGRFULLNAME := null;
    SADDR_HOUSE := null;
    SADDR_BLOCK := null;
    SADDR_BUILDING := null;
    SADDR_FLAT := null;
    SADDR_POST := null;
  end AGNADDRESSESClear;

  procedure PERS_DOC_CODEClear
  as
  begin
    SDOC_SER := null;
    SDOC_NUMB := null;
  end PERS_DOC_CODEClear;

  procedure RF_DOC_CODEClear
  as
  begin
    SRF_SER := null;
    SRF_NUMB := null;
  end RF_DOC_CODEClear;

begin

  if (NFIRST is null) or (NFIRST < 0) then
    NFIRST := 0;
  end if;

  if (NFIRST = 0) then
    PKG_EXT.SET_VALS( SAGNFAMILYNAME, NSAGNFAMILYNAME_ENAB, false );
    PKG_EXT.SET_VALS( SAGNFIRSTNAME, NSAGNFIRSTNAME_ENAB, false );
    PKG_EXT.SET_VALS( SAGNLASTNAME, NSAGNLASTNAME_ENAB, false );
    PKG_EXT.SET_VALS( DAGENT_BORN, NDAGENT_BORN_ENAB, false );
    PKG_EXT.SET_VALS( NRESIDENT_SIGN, NNRESIDENT_SIGN_ENAB, false );
    PKG_EXT.SET_VALS( AGENT_SEX, NAGENT_SEX_ENAB, false );
    PKG_EXT.SET_VALS( SAGENT_PHONE, NSAGENT_PHONE_ENAB, false );
    PKG_EXT.SET_VALS( SAGENT_PHONE2, NSAGENT_PHONE2_ENAB, false );
    PKG_EXT.SET_VALS( SAGENT_MAIL, NSAGENT_MAIL_ENAB, false );
    PKG_EXT.SET_VALS( SGEOGRFULLNAME, NSGEOGRFULLNAME_ENAB, false );
    PKG_EXT.SET_VALS( SADDR_HOUSE, NSADDR_HOUSE_ENAB, false );
    PKG_EXT.SET_VALS( SADDR_BLOCK, NSADDR_BLOCK_ENAB, false );
    PKG_EXT.SET_VALS( SADDR_BUILDING, NSADDR_BUILDING_ENAB, false );
    PKG_EXT.SET_VALS( SADDR_FLAT, NSADDR_FLAT_ENAB, false );
    PKG_EXT.SET_VALS( SADDR_POST, NSADDR_POST_ENAB, false );
    PKG_EXT.SET_VALS( SCITIZENSHIP, NSCITIZENSHIP_ENAB, false );

    PKG_EXT.SET_VALS( SCURNAMES, NSCURNAMES_ENAB, (NIS_UNLOAD = 0) and (NCURNAMES is null) );
    PKG_EXT.SET_VALS( SBANKPRG, NSBANKPRG_ENAB, (NIS_UNLOAD = 0) and (NBANKPRG is null) );
    PKG_EXT.SET_VALS( SBANKACCTYPES, NSBANKACCTYPES_ENAB, (NIS_UNLOAD = 0) and (NBANKACCTYPES is null) );
    PKG_EXT.SET_VALS( NRESIDENT_SIGN, NNRESIDENT_SIGN_ENAB, (NIS_UNLOAD = 0) and (RESIDENT_SIGN = 2) );

    if (NIS_UNLOAD = 1) then

      NSEMBOSS_ENAB:= 0;
      NSCONTROL_INF_ENAB:= 0;
      NNRECIEVE_TYPE_ENAB:= 0;
      NNRECIEVE_CARD_ENAB:= 0;
      NNINCOME_ENAB:= 0;
      NDJOBBEGIN_ENAB:= 0;
      NSSMS_COUNTRY_ENAB := 0;
      NSSMS_PHONE_ENAB := 0;
      NSGEOGRNAME_ENAB := 0;
      NSDOC_CODE_ENAB := 0;
      NSRF_CODE_ENAB := 0;

    end if;

    NFIRST := 1;
  end if;

  case SATTRIB
    when 'SGEOGRNAME' then
      if (SGEOGRNAME is null) then
        AGNADDRESSESClear;
      end if;
    when 'SDOC_CODE' then
      if (SDOC_CODE is null) then
        PERS_DOC_CODEClear;
      end if;
    when 'SRF_CODE' then
      if (SRF_CODE is null) then
        RF_DOC_CODEClear;
      end if;
    else null;
  end case;

end P_UDOT_SLREGOPACCPR_FORM_EDIT;
/

grant execute on P_UDOT_SLREGOPACCPR_FORM_EDIT to public;

create or replace procedure UDOT_GET_ADDRESSES_STR
(
  nRN         in number
 ,sADDRESSES  out varchar2
)
as
  sADDRESS_DESCR  varchar2(2000);
begin
  sADDRESS_DESCR := F_AGNADDRESSES_GET_STR_EX(nRN,'CPRDYUTSVWHBLF');
  --   70   
  UDOT_P_STR2TEXT
  (
    sSTR_VALUE  => sADDRESS_DESCR  --      
   ,nLEN_LINE   => 70              --     ( )
   ,sDELIM      => ' '
  );
  sADDRESSES     := sADDRESS_DESCR;
exception
  when others then
    sADDRESSES := ':';
end UDOT_GET_ADDRESSES_STR;
/

grant execute on UDOT_GET_ADDRESSES_STR to public;

create or replace procedure P_UDOT_CLNPERSONS_GET_AGENT
(
  nCOMPANY    in number,            --   
  sPERS_CODE  in varchar2,          --  
  nAGENT      out number,           --   
  sAGENT      out varchar2,         --  
  nRESIDENT   out number,           --   (1-)
  sCITIZEN    out varchar2,         --  
  sEMBOSS     out varchar2          --  
)
as
  sAGNFAMILY    agnlist.agnfamilyname%type;
  sAGNFIRSTNAME agnlist.agnfirstname%type;
  sSQL          varchar2(2000);
begin
  begin
    select AGN.AGNABBR, AGN.rn, case when AGN.Resident_Sign = 1 then 0 else 1 end
          ,agn.agnfamilyname
          ,agn.agnfirstname
          ,(select ': '||nvl(max(g.geogrname),' ') from geografy g where g.rn = agn.citizenship)
    into SAGENT, nAGENT, nRESIDENT, sAGNFAMILY, sAGNFIRSTNAME, sCITIZEN
    from
      CLNPERSONS        C,
      AGNLIST           AGN
    where C.COMPANY = nCOMPANY
      and C.Code = F_CLNPERSONS_FORMAT_CODE(nCOMPANY,sPERS_CODE,1)
      and C.PERS_AGENT   = AGN.RN;
--   sSQL := 'select UDOT_F_NAME_TO_LAT('''||sAgnfirstname||''')||'' ''||UDOT_F_NAME_TO_LAT('''||sAgnfamily||''') from dual';
--   begin
--     execute immediate sSQL into sEMBOSS;
--   exception
--     when others then
       sEMBOSS := '';
--   end;

  exception
    when NO_DATA_FOUND then
      SAGENT    := '';
      nAGENT    := null;
      nRESIDENT := 0;
      sEMBOSS   := '';
      sCITIZEN  := ':  ';
  end;

end P_UDOT_CLNPERSONS_GET_AGENT;
/

grant execute on P_UDOT_CLNPERSONS_GET_AGENT to public;

create or replace procedure P_UDOT_SLREGOPACCPR_JOINS
(
  nCOMPANY                  in number,       --   
  sCLNPERSONS               in varchar2,     --  ()
  sCURNAMES                 in varchar2,     --  (  ISO)
  sBANKPRG                  in varchar2,     --   ()
  sBANKACCTYPES             in varchar2,     --   ( ) ()
  nCLNPERSONS               out number,      -- 
  nCURNAMES                 out number,      -- 
  nBANKPRG                  out number,      --  
  nBANKACCTYPES             out number       --   ( )
)
as
begin
  -- 
  FIND_CLNPERSONS_CODE( 0, 0, nCOMPANY, sCLNPERSONS, nCLNPERSONS );

  -- 
  if rtrim(sCURNAMES) is not null then
    FIND_CURRENCY_ISO( 0, nCOMPANY, sCURNAMES, nCURNAMES );
  end if;

  --  
  FIND_BANKPRG_CODE( 0, 1, nCOMPANY, sBANKPRG, nBANKPRG );

  --   ( )
  FIND_BANKACCTYPES_CODE( 0, 1, nCOMPANY, sBANKACCTYPES, nBANKACCTYPES );
end P_UDOT_SLREGOPACCPR_JOINS;
/

grant execute on P_UDOT_SLREGOPACCPR_JOINS to public;

create or replace procedure UDOT_GET_AGNDOCUMS_DESCRIPTION
(
  nRN      in number
 ,sDOCUMS  out varchar2
)
as
  nLEN       number;
  nPosCR     number;
  sDOC_DESCR varchar2(2000);
begin
  if nRN is null then
    sDOCUMS := ':';
    return;
  end if;
  select T.NAME||',  '||D.docser||'  '||D.docnumb||',  '||d2s(D.docwhen)||' '||d.docwho||' '||d.depart_code||' (   - "'||G.GEOGRNAME||'" )'
    into sDOC_DESCR
    from AGNDOCUMS   D
        ,AGNPASSTYPE T
        ,GEOGRAFY    G
   where D.rn = nRN
     and D.AGNPASSTYPE = T.RN(+)
     and T.COUNTRY = G.RN(+);
  --   70   
  UDOT_P_STR2TEXT
  (
    sSTR_VALUE  => sDOC_DESCR  --      
   ,nLEN_LINE   => 70          --     ( )
   ,sDELIM      => ' '
  );
  sDOCUMS := sDOC_DESCR;
exception
  when others then
    sDOCUMS := ':';
end UDOT_GET_AGNDOCUMS_DESCRIPTION;
/

grant execute on UDOT_GET_AGNDOCUMS_DESCRIPTION to public;

create or replace procedure P_UDOT_SLREGOPACCPR_EXISTS
(
  nRN                       in number,       --  
  nCOMPANY                  in number,       -- 
  nCRN                      out number,      -- 
  nJUR_PERS                 out number       --  
)
as
begin
  /*   */
  begin
    select CRN,JUR_PERS
      into nCRN,nJUR_PERS
      from UDOT_SLREGOPACCPR
     where RN = nRN
       and COMPANY = nCOMPANY;
  exception
    when NO_DATA_FOUND then
      PKG_MSG.RECORD_NOT_FOUND( nRN,'UdotSalaryRegistersOpenAccountsPersons' );
  end;
end P_UDOT_SLREGOPACCPR_EXISTS;
/

grant execute on P_UDOT_SLREGOPACCPR_EXISTS to public;

create index I_UDOT_SLREGOPACCPR_CRN_FK on UDOT_SLREGOPACCPR(CRN) tablespace &INDX_B1709;

create index I_UDOT_SLREGOPACCPR_JURPERS_FK on UDOT_SLREGOPACCPR(JUR_PERS) tablespace &INDX_B1709;

create index I_UDOT_SLREGOPACCPR_ADDRESS_FK on UDOT_SLREGOPACCPR(AGNADDRESSES) tablespace &INDX_B1709;

create index I_UDOT_SLREGOPACCPR_ACCTYPE_FK on UDOT_SLREGOPACCPR(BANKACCTYPES) tablespace &INDX_B1709;

create or replace procedure P_UDOT_SLREGOPACCPR_GET_ATTRIB
(
  NRN             in number,            --   
  SCITIZENSHIP    out varchar2          -- SCITIZENSHIP
)
as
begin
  begin
    select
      (select FORMAT_HIER_NAME(null,AGN.VERSION,CS.FULLNAME) from GEOGRAFY CS where CS.RN = AGN.CITIZENSHIP) -- sCITIZENSHIP
    into
      SCITIZENSHIP
    from
      UDOT_SLREGOPACCPR T,
      CLNPERSONS        C,
      AGNLIST           AGN
    where T.RN = NRN
      and T.CLNPERSONS   = C.RN
      and C.PERS_AGENT   = AGN.RN
      and exists (select null from V_USERPRIV UP where UP.CATALOG = T.CRN)
      and exists (select null from V_USERPRIV UP where UP.JUR_PERS = T.JUR_PERS and UP.UNITCODE = 'UdotSalaryRegistersOpenAccounts');
  exception
    when NO_DATA_FOUND then
      PKG_MSG.RECORD_NOT_FOUND(NRN, 'UdotSalaryRegistersOpenAccountsPersons');
  end;
end P_UDOT_SLREGOPACCPR_GET_ATTRIB;
/

grant execute on P_UDOT_SLREGOPACCPR_GET_ATTRIB to public;

create or replace procedure P_UDOT_SLREGOPACCPR_BASE_INS
(
  nCOMPANY                  in number,       -- 
  nPRN                      in number,       -- 
  nCLNPERSONS               in number,       -- 
  nAGNADDRESSES             in number,       -- 
  nPERS_DOC                 in number,       --  
  nRF_DOC                   in number,       --     
  nCURNAMES                 in number,       -- 
  nRESIDENT_SIGN            in number,       -- 
  nBANKPRG                  in number,       --  
  nBANKACCTYPES             in number,       --   ( )
  sEMBOSS                   in varchar2,     --  
  sCONTROL_INF              in varchar2,     --  
  nRECIEVE_TYPE             in number,       --  
  sSMS_COUNTRY              in varchar2,     --    
  sSMS_PHONE                in varchar2,     --    
  nRECIEVE_CARD             in number,       --  
  nINCOME                   in number,       --  
  dJOBBEGIN                 in date,         --    
  sACCNT                    in varchar2,     -- 
  nACCNT_OPEN               in number,       --  
  nRN                       out number       --  
)
as
begin
  /*    */
  nRN := gen_id;

  /*     */
  insert into UDOT_SLREGOPACCPR
  (
    RN,
    PRN,
    CLNPERSONS,
    AGNADDRESSES,
    PERS_DOC,
    RF_DOC,
    CURNAMES,
    RESIDENT_SIGN,
    BANKPRG,
    BANKACCTYPES,
    EMBOSS,
    CONTROL_INF,
    RECIEVE_TYPE,
    SMS_COUNTRY,
    SMS_PHONE,
    RECIEVE_CARD,
    INCOME,
    JOBBEGIN,
    ACCNT,
    ACCNT_OPEN
  )
  values
  (
    nRN,
    nPRN,
    nCLNPERSONS,
    nAGNADDRESSES,
    nPERS_DOC,
    nRF_DOC,
    nCURNAMES,
    nRESIDENT_SIGN,
    nBANKPRG,
    nBANKACCTYPES,
    sEMBOSS,
    sCONTROL_INF,
    nRECIEVE_TYPE,
    sSMS_COUNTRY,
    sSMS_PHONE,
    nRECIEVE_CARD,
    nINCOME,
    dJOBBEGIN,
    sACCNT,
    nACCNT_OPEN
  );
end P_UDOT_SLREGOPACCPR_BASE_INS;
/

create index I_UDOT_SLREGOPACCPR_PERSONS_FK on UDOT_SLREGOPACCPR(CLNPERSONS) tablespace &INDX_B1709;

create or replace trigger T_UDOT_SLREGOPACCPR_BINSERT
  before insert on UDOT_SLREGOPACCPR for each row
declare
  nLenBdata   number;
begin
  /*    master- */
  select M.COMPANY, M.CRN, M.JUR_PERS, nvl(M.Is_Unload,0)
    into :new.COMPANY, :new.CRN, :new.JUR_PERS, nLenBdata
    from UDOT_SLREGOPACC  M
   where M.RN = :new.PRN;

  /*     dbf */
  if nLenBdata > 0 then
    p_exception(0, '    dbf .   .');
  end if;

  /*   */
  if ( PKG_IUD.PROLOGUE('UDOT_SLREGOPACCPR', 'I') ) then
    PKG_IUD.REG_RN('RN', :new.RN);
    PKG_IUD.REG_COMPANY('COMPANY', :new.COMPANY);
    PKG_IUD.REG_CRN('CRN', :new.CRN);
    PKG_IUD.REG_PRN('PRN', :new.PRN);
    PKG_IUD.REG_JUR_PERS('JUR_PERS', :new.JUR_PERS);
    PKG_IUD.REG(1, 'CLNPERSONS', :new.CLNPERSONS, 'CLNPERSONS', 'CODE');
    PKG_IUD.REG('AGNADDRESSES', :new.AGNADDRESSES);
    PKG_IUD.REG('PERS_DOC', :new.PERS_DOC);
    PKG_IUD.REG('RF_DOC', :new.RF_DOC);
    PKG_IUD.REG('CURNAMES', :new.CURNAMES);
    PKG_IUD.REG('RESIDENT_SIGN', :new.RESIDENT_SIGN);
    PKG_IUD.REG('BANKPRG', :new.BANKPRG);
    PKG_IUD.REG('BANKACCTYPES', :new.BANKACCTYPES);
    PKG_IUD.REG('EMBOSS', :new.EMBOSS);
    PKG_IUD.REG('CONTROL_INF', :new.CONTROL_INF);
    PKG_IUD.REG('RECIEVE_TYPE', :new.RECIEVE_TYPE);
    PKG_IUD.REG('SMS_COUNTRY', :new.SMS_COUNTRY);
    PKG_IUD.REG('SMS_PHONE', :new.SMS_PHONE);
    PKG_IUD.REG('RECIEVE_CARD', :new.RECIEVE_CARD);
    PKG_IUD.REG('INCOME', :new.INCOME);
    PKG_IUD.REG('JOBBEGIN', :new.JOBBEGIN);
    PKG_IUD.REG('ACCNT', :new.ACCNT);
    PKG_IUD.REG('ACCNT_OPEN', :new.ACCNT_OPEN);
    PKG_IUD.EPILOGUE;
  end if;
end T_UDOT_SLREGOPACCPR_BINSERT;
/

create or replace function UDOT_F_SLREGOPACC_DOCS_DICT_DS
(
  nRN          in number     --        
 ,sAGENT       in varchar2   --  
 ,sIN_PARAM    in varchar2   --     
 ,sOUT_PARAM   in varchar2   --     
 ,sCONTROL     in varchar2   --          
)
return varchar2
as
  nPERS_AGENT   number;
  nCOMPANY      number;
  nVERSION      number;
begin
  delete from UDOT_VIRTUALDICT;
  nCOMPANY := pkg_session.GET_COMPANY;
  find_version_by_company( nCOMPANY, 'AGNLIST', nVERSION);
  if nRN is not null then
    select nvl(max(C.PERS_AGENT),0)
      into nPERS_AGENT
      from UDOT_SLREGOPACCPR S
          ,CLNPERSONS        C
     where S.rn = nRN
       and S.CLNPERSONS = C.RN;
  elsif sAGENT is not null then
    select nvl(max(a.rn),0)
      into nPERS_AGENT
      from AGNLIST  a
     where a.version = nVERSION
       and a.agnabbr = sAGENT;
  end if;

  return UDOT_GET_PERSDOCUMS_DICT_DESCR( nPERS_AGENT, sIN_PARAM, sOUT_PARAM, sCONTROL);

end UDOT_F_SLREGOPACC_DOCS_DICT_DS;
/

grant execute on UDOT_F_SLREGOPACC_DOCS_DICT_DS to public;

create index I_UDOT_SLREGOPACCPR_CURNAME_FK on UDOT_SLREGOPACCPR(CURNAMES) tablespace &INDX_B1709;

create or replace trigger T_UDOT_SLREGOPACCPR_BUPDATE
  before update on UDOT_SLREGOPACCPR for each row
declare
  nLenBdata   number;
begin
  /*     */
  PKG_UNCHANGE.CHECK_NE('UDOT_SLREGOPACCPR', 'RN', :new.RN, :old.RN);
  PKG_UNCHANGE.CHECK_NE('UDOT_SLREGOPACCPR', 'COMPANY', :new.COMPANY, :old.COMPANY);
  PKG_UNCHANGE.CHECK_NE('UDOT_SLREGOPACCPR', 'PRN', :new.PRN, :old.PRN);
  PKG_UNCHANGE.CHECK_NE('UDOT_SLREGOPACCPR', 'JUR_PERS', :new.JUR_PERS, :old.JUR_PERS);

  /*         */
  if (CMP_NUM(:old.CRN,:new.CRN) = 0 or
      CMP_NUM(:old.JUR_PERS,:new.JUR_PERS) = 0) then
    return;
  end if;

  /*    master- */
  select nvl(M.Is_Unload,0)
    into nLenBdata
    from UDOT_SLREGOPACC  M
   where M.RN = :new.PRN;

  /*     dbf */
  if nLenBdata > 0 then
    p_exception(0, '    dbf .   .');
  end if;

  /*   */
  if ( PKG_IUD.PROLOGUE('UDOT_SLREGOPACCPR', 'U') ) then
    PKG_IUD.REG_RN('RN', :new.RN, :old.RN);
    PKG_IUD.REG_COMPANY('COMPANY', :new.COMPANY, :old.COMPANY);
    PKG_IUD.REG_CRN('CRN', :new.CRN, :old.CRN);
    PKG_IUD.REG_PRN('PRN', :new.PRN, :old.PRN);
    PKG_IUD.REG_JUR_PERS('JUR_PERS', :new.JUR_PERS, :old.JUR_PERS);
    PKG_IUD.REG(1, 'CLNPERSONS', :new.CLNPERSONS, :old.CLNPERSONS, 'CLNPERSONS', 'CODE');
    PKG_IUD.REG('AGNADDRESSES', :new.AGNADDRESSES, :old.AGNADDRESSES);
    PKG_IUD.REG('PERS_DOC', :new.PERS_DOC, :old.PERS_DOC);
    PKG_IUD.REG('RF_DOC', :new.RF_DOC, :old.RF_DOC);
    PKG_IUD.REG('CURNAMES', :new.CURNAMES, :old.CURNAMES);
    PKG_IUD.REG('RESIDENT_SIGN', :new.RESIDENT_SIGN, :old.RESIDENT_SIGN);
    PKG_IUD.REG('BANKPRG', :new.BANKPRG, :old.BANKPRG);
    PKG_IUD.REG('BANKACCTYPES', :new.BANKACCTYPES, :old.BANKACCTYPES);
    PKG_IUD.REG('EMBOSS', :new.EMBOSS, :old.EMBOSS);
    PKG_IUD.REG('CONTROL_INF', :new.CONTROL_INF, :old.CONTROL_INF);
    PKG_IUD.REG('RECIEVE_TYPE', :new.RECIEVE_TYPE, :old.RECIEVE_TYPE);
    PKG_IUD.REG('SMS_COUNTRY', :new.SMS_COUNTRY, :old.SMS_COUNTRY);
    PKG_IUD.REG('SMS_PHONE', :new.SMS_PHONE, :old.SMS_PHONE);
    PKG_IUD.REG('RECIEVE_CARD', :new.RECIEVE_CARD, :old.RECIEVE_CARD);
    PKG_IUD.REG('INCOME', :new.INCOME, :old.INCOME);
    PKG_IUD.REG('JOBBEGIN', :new.JOBBEGIN, :old.JOBBEGIN);
    PKG_IUD.REG('ACCNT', :new.ACCNT, :old.ACCNT);
    PKG_IUD.REG('ACCNT_OPEN', :new.ACCNT_OPEN, :old.ACCNT_OPEN);
    PKG_IUD.EPILOGUE;
  end if;
end T_UDOT_SLREGOPACCPR_BUPDATE;
/

create or replace trigger T_UDOT_SLREGOPACCPR_ADELETE
  after delete on UDOT_SLREGOPACCPR for each row
begin
  /*       */
  P_LOG_DELETE( :old.RN,'UdotSalaryRegistersOpenAccountsPersons' );
end;
/

create index I_UDOT_SLREGOPACCPR_BANKPRG_FK on UDOT_SLREGOPACCPR(BANKPRG) tablespace &INDX_B1709;

create or replace procedure P_UDOT_SLREGOPACCPR_GET_AGENT
(
  NRN         in number,            --   
  SAGENT      out varchar2          -- SAGENT
)
as
begin
  begin
    select
      AGN.AGNABBR
    into
      SAGENT
    from
      UDOT_SLREGOPACCPR T,
      CLNPERSONS        C,
      AGNLIST           AGN
    where T.RN = NRN
      and T.CLNPERSONS   = C.RN
      and C.PERS_AGENT   = AGN.RN
      and exists (select null from V_USERPRIV UP where UP.CATALOG = T.CRN)
      and exists (select null from V_USERPRIV UP where UP.JUR_PERS = T.JUR_PERS and UP.UNITCODE = 'UdotSalaryRegistersOpenAccounts');
  exception
    when NO_DATA_FOUND then
      PKG_MSG.RECORD_NOT_FOUND(NRN, 'UdotSalaryRegistersOpenAccountsPersons');
  end;
end P_UDOT_SLREGOPACCPR_GET_AGENT;
/

grant execute on P_UDOT_SLREGOPACCPR_GET_AGENT to public;

create or replace function UDOT_F_SLREGOPACC_ADDR_DICT_DS
(
  nRN          in number     --        
 ,sAGENT       in varchar2   --  
 ,sIN_PARAM    in varchar2   --     
 ,sOUT_PARAM   in varchar2   --     
 ,sCONTROL     in varchar2   --          
)
return varchar2
as
  nPERS_AGENT   number;
  nCOMPANY      number;
  nVERSION      number;
begin
  delete from UDOT_VIRTUALDICT;
  nCOMPANY := pkg_session.GET_COMPANY;
  find_version_by_company( nCOMPANY, 'AGNLIST', nVERSION);
  if nRN is not null then
    select nvl(max(C.PERS_AGENT),0)
      into nPERS_AGENT
      from UDOT_SLREGOPACCPR S
          ,CLNPERSONS        C
     where S.rn = nRN
       and S.CLNPERSONS = C.RN;
  elsif sAGENT is not null then
    select nvl(max(a.rn),0)
      into nPERS_AGENT
      from AGNLIST  a
     where a.version = nVERSION
       and a.agnabbr = sAGENT;
  end if;

  return UDOT_GET_AGNADDRESS_DICT_DESCR( nPERS_AGENT, sIN_PARAM, sOUT_PARAM, sCONTROL);

end UDOT_F_SLREGOPACC_ADDR_DICT_DS;
/

grant execute on UDOT_F_SLREGOPACC_ADDR_DICT_DS to public;

/* V_UDOT_SLREGOPACCPR */
create or replace view V_UDOT_SLREGOPACCPR (
  NRN,
  NCOMPANY,
  NCRN,
  NPRN,
  NJUR_PERS,
  NCLNPERSONS,
  SCLNPERSONS,
  SSURNAME,
  SFIRSTNAME,
  SLASTNAME,
  NAGNLIST,
  SAGNLIST,
  DAGNBURN,
  NSEX,
  SCITIZENSHIP,
  SPHONE,
  SPHONE2,
  SMAIL,
  NAGNADDRESSES,
  SAGNADDRESSES_FULLNAME,
  SAGNADDRESSES_GEOGRNAME,
  SAGNADDRESSES_HOUSE,
  SAGNADDRESSES_BLOCK,
  SAGNADDRESSES_BUILDING,
  SAGNADDRESSES_FLAT,
  SAGNADDRESSES_POST,
  NPERS_DOC,
  SPERS_DOC_CODE,
  SPERS_DOC_SER,
  SPERS_DOC_NUMB,
  NRF_DOC,
  SRF_DOC_CODE,
  SRF_DOC_SER,
  SRF_DOC_NUMB,
  NCURNAMES,
  SCURNAMES,
  NRESIDENT_SIGN,
  NBANKPRG,
  SBANKPRG,
  NBANKACCTYPES,
  SBANKACCTYPES,
  SEMBOSS,
  SCONTROL_INF,
  NRECIEVE_TYPE,
  SSMS_COUNTRY,
  SSMS_PHONE,
  NRECIEVE_CARD,
  NINCOME,
  DJOBBEGIN,
  SACCNT,
  NACCNT_OPEN,
  NCURNAMES_P,
  NRESIDENT_SIGN_P,
  NBANKPRG_P,
  NBANKACCTYPES_P
) as
select
  T.RN,                                 -- nRN
  T.COMPANY,                            -- nCOMPANY
  T.CRN,                                -- nCRN
  T.PRN,                                -- nPRN
  T.JUR_PERS,                           -- nJUR_PERS
  T.CLNPERSONS,                         -- nCLNPERSONS
  C.CODE,                               -- sCLNPERSONS
  AGN.AGNFAMILYNAME,                    -- sSURNAME
  AGN.AGNFIRSTNAME,                     -- sFIRSTNAME
  AGN.AGNLASTNAME,                      -- sLASTNAME
  C.PERS_AGENT,                         -- nAGNLIST
  AGN.AGNABBR,                          -- sAGNLIST
  AGN.AGNBURN,                          -- dAGNBURN
  AGN.SEX,                              -- nSEX
  (select FORMAT_HIER_NAME(null,AGN.VERSION,CS.FULLNAME) from GEOGRAFY CS where CS.RN = AGN.CITIZENSHIP), -- sCITIZENSHIP
  AGN.PHONE,                            -- sPHONE
  AGN.PHONE2,                           -- sPHONE2
  AGN.MAIL,                             -- sMAIL
  T.AGNADDRESSES,                       -- nAGNADDRESSES
  FORMAT_HIER_NAME(null,AGN.VERSION,G.FULLNAME),-- sAGNADDRESSES_FULLNAME
  G.GEOGRNAME,                          -- sAGNADDRESSES_GEOGRNAME
  A.ADDR_HOUSE,                         -- sAGNADDRESSES_HOUSE
  A.ADDR_BLOCK,                         -- sAGNADDRESSES_BLOCK
  A.ADDR_BUILDING,                      -- sAGNADDRESSES_BUILDING
  A.ADDR_FLAT,                          -- sAGNADDRESSES_FLAT
  A.ADDR_POST,                          -- sAGNADDRESSES_POST
  T.PERS_DOC,                           -- nPERS_DOC
  A3.CODE,                              -- sPERS_DOC_CODE
  A2.DOCSER,                            -- sPERS_DOC_SER
  A2.DOCNUMB,                           -- sPERS_DOC_NUMB
  T.RF_DOC,                             -- nRF_DOC
  A5.CODE,                              -- sRF_DOC_CODE
  A4.DOCSER,                            -- sRF_DOC_SER
  A4.DOCNUMB,                           -- sRF_DOC_NUMB
  T.CURNAMES,                           -- nCURNAMES
  (select C2.INTCODE from CURNAMES C2 where C2.RN = T.CURNAMES),-- sCURNAMES
  T.RESIDENT_SIGN,                      -- nRESIDENT_SIGN
  T.BANKPRG,                            -- nBANKPRG
  (select B.CODE from BANKPRG B where B.RN = T.BANKPRG),-- sBANKPRG
  T.BANKACCTYPES,                       -- nBANKACCTYPES
  (select B2.CODE from BANKACCTYPES B2 where B2.RN = T.BANKACCTYPES),-- sBANKACCTYPES
  T.EMBOSS,                             -- sEMBOSS
  T.CONTROL_INF,                        -- sCONTROL_INF
  T.RECIEVE_TYPE,                       -- nRECIEVE_TYPE
  T.SMS_COUNTRY,                        -- sSMS_COUNTRY
  T.SMS_PHONE,                          -- sSMS_PHONE
  T.RECIEVE_CARD,                       -- nRECIEVE_CARD
  T.INCOME,                             -- nINCOME
  T.JOBBEGIN,                           -- dJOBBEGIN
  T.ACCNT,                              -- sACCNT
  T.ACCNT_OPEN,                         -- nACCNT_OPEN
  M.CURNAMES,                           -- nCURNAMES_P
  M.RESIDENT_SIGN,                      -- nRESIDENT_SIGN_P
  M.BANKPRG,                            -- nBANKPRG_P
  M.BANKACCTYPES                        -- nBANKACCTYPES_P
from
  UDOT_SLREGOPACCPR T,
  UDOT_SLREGOPACC   M,
  CLNPERSONS        C,
  AGNLIST           AGN,
  AGNADDRESSES      A,
  GEOGRAFY          G,
  AGNDOCUMS         A2,
  AGNPASSTYPE       A3,
  AGNDOCUMS         A4,
  AGNPASSTYPE       A5
where T.PRN          = M.RN
  and T.CLNPERSONS   = C.RN
  and C.PERS_AGENT   = AGN.RN
  and T.AGNADDRESSES = A.RN(+)
  and A.GEOGRAFY_RN  = G.RN(+)
  and T.PERS_DOC     = A2.RN(+)
  and A2.AGNPASSTYPE = A3.RN(+)
  and T.RF_DOC       = A4.RN(+)
  and A4.AGNPASSTYPE = A5.RN(+)
  and exists (select null from V_USERPRIV UP where UP.CATALOG = T.CRN)
  and exists (select null from V_USERPRIV UP where UP.JUR_PERS = T.JUR_PERS and UP.UNITCODE = 'UdotSalaryRegistersOpenAccounts')
;

grant select on V_UDOT_SLREGOPACCPR to public;

create index I_UDOT_SLREGOPACCPR_RF_DOC_FK on UDOT_SLREGOPACCPR(RF_DOC) tablespace &INDX_B1709;

create or replace trigger T_UDOT_SLREGOPACCPR_BDELETE
  before delete on UDOT_SLREGOPACCPR for each row
declare
  nLenBdata    number;
begin
  /*    master- */
  select nvl(m.is_unload,0)
    into nLenBdata
    from UDOT_SLREGOPACC  M
   where M.RN = :old.PRN;

  /*     dbf */
  if nLenBdata > 0 then
    p_exception(0, '    dbf .   .');
  end if;
  /*   */
  if ( PKG_IUD.PROLOGUE('UDOT_SLREGOPACCPR', 'D') ) then
    PKG_IUD.REG_RN('RN', :old.RN);
    PKG_IUD.REG_COMPANY('COMPANY', :old.COMPANY);
    PKG_IUD.REG_CRN('CRN', :old.CRN);
    PKG_IUD.REG_PRN('PRN', :old.PRN);
    PKG_IUD.REG_JUR_PERS('JUR_PERS', :old.JUR_PERS);
    PKG_IUD.REG(1, 'CLNPERSONS', :old.CLNPERSONS, 'CLNPERSONS', 'CODE');
    PKG_IUD.REG('AGNADDRESSES', :old.AGNADDRESSES);
    PKG_IUD.REG('PERS_DOC', :old.PERS_DOC);
    PKG_IUD.REG('RF_DOC', :old.RF_DOC);
    PKG_IUD.REG('CURNAMES', :old.CURNAMES);
    PKG_IUD.REG('RESIDENT_SIGN', :old.RESIDENT_SIGN);
    PKG_IUD.REG('BANKPRG', :old.BANKPRG);
    PKG_IUD.REG('BANKACCTYPES', :old.BANKACCTYPES);
    PKG_IUD.REG('EMBOSS', :old.EMBOSS);
    PKG_IUD.REG('CONTROL_INF', :old.CONTROL_INF);
    PKG_IUD.REG('RECIEVE_TYPE', :old.RECIEVE_TYPE);
    PKG_IUD.REG('SMS_COUNTRY', :old.SMS_COUNTRY);
    PKG_IUD.REG('SMS_PHONE', :old.SMS_PHONE);
    PKG_IUD.REG('RECIEVE_CARD', :old.RECIEVE_CARD);
    PKG_IUD.REG('INCOME', :old.INCOME);
    PKG_IUD.REG('JOBBEGIN', :old.JOBBEGIN);
    PKG_IUD.REG('ACCNT', :old.ACCNT);
    PKG_IUD.REG('ACCNT_OPEN', :old.ACCNT_OPEN);
    PKG_IUD.EPILOGUE;
  end if;
end T_UDOT_SLREGOPACCPR_BDELETE;
/

create or replace procedure P_UDOT_SLREGOPACCPR_BASE_UPD
(
  nRN                       in number,       --  
  nCOMPANY                  in number,       -- 
  nCLNPERSONS               in number,       -- 
  nAGNADDRESSES             in number,       -- 
  nPERS_DOC                 in number,       --  
  nRF_DOC                   in number,       --     
  nCURNAMES                 in number,       -- 
  nRESIDENT_SIGN            in number,       -- 
  nBANKPRG                  in number,       --  
  nBANKACCTYPES             in number,       --   ( )
  sEMBOSS                   in varchar2,     --  
  sCONTROL_INF              in varchar2,     --  
  nRECIEVE_TYPE             in number,       --  
  sSMS_COUNTRY              in varchar2,     --    
  sSMS_PHONE                in varchar2,     --    
  nRECIEVE_CARD             in number,       --  
  nINCOME                   in number,       --  
  dJOBBEGIN                 in date,         --    
  sACCNT                    in varchar2,     -- 
  nACCNT_OPEN               in number        --  
)
as
begin
  /*     */
  update UDOT_SLREGOPACCPR
     set CLNPERSONS    = nCLNPERSONS,
         AGNADDRESSES  = nAGNADDRESSES,
         PERS_DOC      = nPERS_DOC,
         RF_DOC        = nRF_DOC,
         CURNAMES      = nCURNAMES,
         RESIDENT_SIGN = nRESIDENT_SIGN,
         BANKPRG       = nBANKPRG,
         BANKACCTYPES  = nBANKACCTYPES,
         EMBOSS        = sEMBOSS,
         CONTROL_INF   = sCONTROL_INF,
         RECIEVE_TYPE  = nRECIEVE_TYPE,
         SMS_COUNTRY   = sSMS_COUNTRY,
         SMS_PHONE     = sSMS_PHONE,
         RECIEVE_CARD  = nRECIEVE_CARD,
         INCOME        = nINCOME,
         JOBBEGIN      = dJOBBEGIN,
         ACCNT         = sACCNT,
         ACCNT_OPEN    = nACCNT_OPEN
   where RN = nRN
     and COMPANY = nCOMPANY;

  if (SQL%NOTFOUND) then
    PKG_MSG.RECORD_NOT_FOUND( nRN,'UdotSalaryRegistersOpenAccountsPersons' );
  end if;
end P_UDOT_SLREGOPACCPR_BASE_UPD;
/

create or replace procedure P_UDOT_SLREGOPACCPR_BASE_DEL
(
  nRN                       in number,       --  
  nCOMPANY                  in number        -- 
)
as
begin
  /*     */
  delete
    from UDOT_SLREGOPACCPR
   where RN = nRN
     and COMPANY = nCOMPANY;

  if (SQL%NOTFOUND) then
    PKG_MSG.RECORD_NOT_FOUND( nRN,'UdotSalaryRegistersOpenAccountsPersons' );
  end if;
end P_UDOT_SLREGOPACCPR_BASE_DEL;
/

create index I_UDOT_SLREGOPACCPR_PERSDOC_FK on UDOT_SLREGOPACCPR(PERS_DOC) tablespace &INDX_B1709;

create or replace procedure P_UDOT_SLREGOPACCPR_INSERT
(
  nCOMPANY                  in number,       -- 
  nPRN                      in number,       -- 
  sCLNPERSONS               in varchar2,     --  ()
  nAGNADDRESSES             in number,       -- 
  nPERS_DOC                 in number,       --  
  nRF_DOC                   in number,       --     
  sCURNAMES                 in varchar2,     --  (  ISO)
  nRESIDENT_SIGN            in number,       -- 
  sBANKPRG                  in varchar2 default null,     --   ()
  sBANKACCTYPES             in varchar2 default null,     --   ( ) ()
  sEMBOSS                   in varchar2,     --  
  sCONTROL_INF              in varchar2 default null,     --  
  nRECIEVE_TYPE             in number,       --  
  sSMS_COUNTRY              in varchar2 default null,     --    
  sSMS_PHONE                in varchar2 default null,     --    
  nRECIEVE_CARD             in number,       --  
  nINCOME                   in number default 0,          --  
  dJOBBEGIN                 in date default null,         --    
  sACCNT                    in varchar2 default null,     -- 
  nACCNT_OPEN               in number default 0,          --  
  nRN                       out number                    --  
)
as
  nCRN                      PKG_STD.tREF;
  nJUR_PERS                 PKG_STD.tREF;
  nCLNPERSONS               PKG_STD.tREF;    -- 
  nCURNAMES                 PKG_STD.tREF;    -- 
  nBANKPRG                  PKG_STD.tREF;    --  
  nBANKACCTYPES             PKG_STD.tREF;    --   ( )
  nIS_UNLOAD                pkg_std.tref;
begin
  /*  master  */
  P_UDOT_SLREGOPACC_EXISTS(nPRN, nCOMPANY, nCRN, nJUR_PERS, nIS_UNLOAD);

  /*   */
  P_UDOT_SLREGOPACCPR_JOINS
  (
    nCOMPANY,
    sCLNPERSONS,
    sCURNAMES,
    sBANKPRG,
    sBANKACCTYPES,
    nCLNPERSONS,
    nCURNAMES,
    nBANKPRG,
    nBANKACCTYPES
  );

  /*     */
  PKG_ENV.PROLOGUE( nCOMPANY,null,nCRN,nJUR_PERS,null,'UdotSalaryRegistersOpenAccountsPersons','UDOT_SLREGOPACCPR_INSERT','UDOT_SLREGOPACCPR' );

  /*   */
  P_UDOT_SLREGOPACCPR_BASE_INS
  (
    nCOMPANY,
    nPRN,
    nCLNPERSONS,
    nAGNADDRESSES,
    nPERS_DOC,
    nRF_DOC,
    nCURNAMES,
    nRESIDENT_SIGN,
    nBANKPRG,
    nBANKACCTYPES,
    sEMBOSS,
    sCONTROL_INF,
    nRECIEVE_TYPE,
    sSMS_COUNTRY,
    sSMS_PHONE,
    nRECIEVE_CARD,
    nvl(nINCOME,0),
    dJOBBEGIN,
    sACCNT,
    nvl(nACCNT_OPEN,0),
    nRN
  );

  /*     */
  PKG_ENV.EPILOGUE( nCOMPANY,null,nCRN,nJUR_PERS,null,'UdotSalaryRegistersOpenAccountsPersons','UDOT_SLREGOPACCPR_INSERT','UDOT_SLREGOPACCPR',nRN );
end P_UDOT_SLREGOPACCPR_INSERT;
/

grant execute on P_UDOT_SLREGOPACCPR_INSERT to public;

create or replace procedure P_UDOT_SLREGOPACCPR_DELETE
(
  nRN                       in number,       --  
  nCOMPANY                  in number        -- 
)
as
  nCRN                      PKG_STD.tREF;    -- 
  nJUR_PERS                 PKG_STD.tREF;    --  
begin
  /*   */
  P_UDOT_SLREGOPACCPR_EXISTS
  (
    nRN,
    nCOMPANY,
    nCRN,
    nJUR_PERS
  );

  /*     */
  PKG_ENV.PROLOGUE( nCOMPANY,null,nCRN,nJUR_PERS,null,'UdotSalaryRegistersOpenAccountsPersons','UDOT_SLREGOPACCPR_DELETE','UDOT_SLREGOPACCPR',nRN );

  /*   */
  P_UDOT_SLREGOPACCPR_BASE_DEL
  (
    nRN,
    nCOMPANY
  );

  /*     */
  PKG_ENV.EPILOGUE( nCOMPANY,null,nCRN,nJUR_PERS,null,'UdotSalaryRegistersOpenAccountsPersons','UDOT_SLREGOPACCPR_DELETE','UDOT_SLREGOPACCPR',nRN );
end P_UDOT_SLREGOPACCPR_DELETE;
/

grant execute on P_UDOT_SLREGOPACCPR_DELETE to public;

create or replace procedure P_UDOT_SLREGOPACCPR_UPDATE
(
  nRN                       in number,       --  
  nCOMPANY                  in number,       -- 
  sCLNPERSONS               in varchar2,     --  ()
  nAGNADDRESSES             in number,       -- 
  nPERS_DOC                 in number,       --  
  nRF_DOC                   in number,       --     
  sCURNAMES                 in varchar2 default null,     --  (  ISO)
  nRESIDENT_SIGN            in number,       -- 
  sBANKPRG                  in varchar2 default null,     --   ()
  sBANKACCTYPES             in varchar2 default null,     --   ( ) ()
  sEMBOSS                   in varchar2,     --  
  sCONTROL_INF              in varchar2 default null,     --  
  nRECIEVE_TYPE             in number,       --  
  sSMS_COUNTRY              in varchar2 default null,     --    
  sSMS_PHONE                in varchar2 default null,     --    
  nRECIEVE_CARD             in number,       --  
  nINCOME                   in number default 0,          --  
  dJOBBEGIN                 in date default null,         --    
  sACCNT                    in varchar2 default null,     -- 
  nACCNT_OPEN               in number default 0           --  
)
as
  nCRN                      PKG_STD.tREF;    -- 
  nJUR_PERS                 PKG_STD.tREF;    --  
  nCLNPERSONS               PKG_STD.tREF;    -- 
  nCURNAMES                 PKG_STD.tREF;    -- 
  nBANKPRG                  PKG_STD.tREF;    --  
  nBANKACCTYPES             PKG_STD.tREF;    --   ( )
begin
  /*   */
  P_UDOT_SLREGOPACCPR_EXISTS
  (
    nRN,
    nCOMPANY,
    nCRN,
    nJUR_PERS
  );

  /*     */
  PKG_ENV.PROLOGUE( nCOMPANY,null,nCRN,nJUR_PERS,null,'UdotSalaryRegistersOpenAccountsPersons','UDOT_SLREGOPACCPR_UPDATE','UDOT_SLREGOPACCPR',nRN );

  /*   */
  P_UDOT_SLREGOPACCPR_JOINS
  (
    nCOMPANY,
    sCLNPERSONS,
    sCURNAMES,
    sBANKPRG,
    sBANKACCTYPES,
    nCLNPERSONS,
    nCURNAMES,
    nBANKPRG,
    nBANKACCTYPES
  );

  /*   */
  P_UDOT_SLREGOPACCPR_BASE_UPD
  (
    nRN,
    nCOMPANY,
    nCLNPERSONS,
    nAGNADDRESSES,
    nPERS_DOC,
    nRF_DOC,
    nCURNAMES,
    nRESIDENT_SIGN,
    nBANKPRG,
    nBANKACCTYPES,
    sEMBOSS,
    sCONTROL_INF,
    nRECIEVE_TYPE,
    sSMS_COUNTRY,
    sSMS_PHONE,
    nRECIEVE_CARD,
    nvl(nINCOME,0),
    dJOBBEGIN,
    sACCNT,
    nvl(nACCNT_OPEN,0)
  );

  /*     */
  PKG_ENV.EPILOGUE( nCOMPANY,null,nCRN,nJUR_PERS,null,'UdotSalaryRegistersOpenAccountsPersons','UDOT_SLREGOPACCPR_UPDATE','UDOT_SLREGOPACCPR',nRN );
end P_UDOT_SLREGOPACCPR_UPDATE;
/

grant execute on P_UDOT_SLREGOPACCPR_UPDATE to public;

create or replace procedure P_UDOT_SLREGOPACC_FORMING
(
  nCOMPANY         in number,
  nIDENT           in number,   -- 
  nRN              in number,   -- 
  sNONRES          in varchar2, --  
  sGRINCOME        in varchar2, --      
  nRECIEVE_TYPE    in number,   --   ()
  nRECIEVE_CARD    in number,   --  
  sEMBOSS_PROC     in varchar2, --    
  dFORM_DATE       in date
)
as
  nSLREGOPACCPR    PKG_STD.tREF;
  nGRINCOME        PKG_STD.tREF;
  nEMBOSS_PROC     PKG_STD.tREF;
  nAGNADDRESSES    PKG_STD.tREF;
  nPERS_DOC        PKG_STD.tREF;
  nRF_DOC          PKG_STD.tREF;
  nTMP             PKG_STD.tREF;
  sTMP             PKG_STD.tSTRING;
  nINCOME          UDOT_SLREGOPACCPR.INCOME%type;
  dBGN             date;
  dEND             date;
  nBEG             integer;
  nEND             integer;
  nCOUNT           binary_integer;
  sSEQSYMB         varchar2(255) := GET_OPTIONS_STR('SeqSymb', nCOMPANY);
begin
  delete from IDLIST;
  /*   */
  for i in 1..STRCNT(sNONRES,sSEQSYMB) loop
    FIND_SLANLSIGNS_CODE(0,1,nCOMPANY,STRTOK(sNONRES,sSEQSYMB,i),nTMP);
    if nTMP is not null then
      insert into IDLIST (ID) values (nTMP);
    end if;
  end loop;
  /*       */
  FIND_SLCOMPGR_CODE(0, 1, nCOMPANY, sGRINCOME, nGRINCOME);
  /*     */
  FIND_USERPROCS_CODE(1, sEMBOSS_PROC, nEMBOSS_PROC);

  select count(*)
    into nCOUNT
    from DUAL
   where exists
      (
        select null
          from UDOT_SLREGOPACCPR
         where PRN = nRN
      );
  if nCOUNT = 1 then
    P_EXCEPTION(0, '   !');
  end if;

  for rec in
  (
    select CRN,
           JUR_PERS,
           DOC_DATE,
           RESIDENT_SIGN,
           CURNAMES,
           BANKPRG,
           BANKACCTYPES
      from UDOT_SLREGOPACC
     where RN = nRN
  )
  loop
    /*     */
    PKG_ENV.PROLOGUE( nCOMPANY,null,rec.CRN,rec.JUR_PERS,null,'UdotSalaryRegistersOpenAccounts','UDOT_SLREGOPACC_FORM','UDOT_SLREGOPACC',nRN );

    dBGN := trunc(rec.DOC_DATE, 'MM');
    dEND := last_day(dBGN);
    nEND := D_YEAR(rec.DOC_DATE)*12 + D_MONTH(rec.DOC_DATE);
    nBEG := nEND - 5;

    -- 
    for recs in
    (
      select C.RN,
             C.PERS_AGENT,
             A.VERSION,
             decode(A.RESIDENT_SIGN,0,1,0) RESIDENT_SIGN,
             nvl(C.LAST_JOBBEG_DATE,C.JOBBEGIN_DATE) JOBBEGIN_DATE
        from SELECTLIST S,
             CLNPERSONS C,
             AGNLIST    A
       where S.DOCUMENT   = C.RN
         and C.PERS_AGENT = A.RN
         and S.IDENT = nIDENT
    )
    loop
      --  
      if recs.RESIDENT_SIGN = 1 and sNONRES is not null then
        select count(*)
          into nCOUNT
          from DUAL
         where exists
            (
              select null
                from CLNPERSADDINF
               where PRN = recs.RN
                 and SLANLSIGNS in (select ID from IDLIST)
                 and BEGIN_DATE <= dEND
                 and (END_DATE >= dBGN or END_DATE is null)
            );
        if nCOUNT > 0 then
          recs.RESIDENT_SIGN := 0;
        end if;
      end if;

      if rec.RESIDENT_SIGN = 2 or rec.RESIDENT_SIGN = recs.RESIDENT_SIGN then
        --  
        begin
          select nvl(sum(S.SUM * decode(instr(C.FORMULA,'-'),0,1,-1) * decode(S.REVERSE,0,1,-1)), 0)
            into nINCOME
            from SLPAYS         S,
                 SLCOMPGRSTRUCT C
           where S.SLCOMPCHARGES = C.SLCOMPCHARGES
             and S.CLNPERSONS = recs.RN
             and S.YEAR*12 + S.MONTH between nBEG and nEND
             and C.PRN = nGRINCOME;
        exception
          when NO_DATA_FOUND then
            nINCOME := 0;
        end;

        --      
        P_PDUP_UDOT_SLREGOPACCPR_EMBOS(nEMBOSS_PROC, nCOMPANY, recs.PERS_AGENT, sTMP);

        -- 
        nAGNADDRESSES := null;
        for reca in
        (
          select RN
            from AGNADDRESSES
           where PRN = recs.PERS_AGENT
             and PRIMARY_SIGN + REGISTRATION_SIGN > 0
             and (REGISTRATION_DATE is null or REGISTRATION_DATE <= rec.DOC_DATE)
             and (REGISTRATION_END is null or REGISTRATION_END >= rec.DOC_DATE)
           order by PRIMARY_SIGN desc
        )
        loop
          nAGNADDRESSES := reca.RN;
          exit;
        end loop;

        --  
        begin
          select RN
            into nPERS_DOC
            from AGNDOCUMS
           where PRN     = recs.PERS_AGENT
             and VERSION = recs.VERSION
             and DEFAULT_SIGN = 1;
        exception
          when NO_DATA_FOUND or TOO_MANY_ROWS then
            nPERS_DOC := null;
        end;

        if recs.RESIDENT_SIGN = 0 then
          --     
          begin
            select D.RN
              into nRF_DOC
              from AGNDOCUMS   D,
                   AGNPASSTYPE T
             where D.AGNPASSTYPE = T.RN(+)
               and D.PRN         = recs.PERS_AGENT
               and D.VERSION     = recs.VERSION
               and (D.DOC_BEGINDATE is null or D.DOC_BEGINDATE <= rec.DOC_DATE)
               and (D.DOC_ENDDATE is null or D.DOC_ENDDATE >= rec.DOC_DATE)
               and T.GNI_CODE in ('11','12','13','15','18')
               and rownum = 1;
          exception
            when NO_DATA_FOUND then
              nRF_DOC := null;
          end;
        else
          nRF_DOC := null;
        end if;

        --  
        P_UDOT_SLREGOPACCPR_BASE_INS
        (
          nCOMPANY,
          nRN,
          recs.RN,
          nAGNADDRESSES,
          nPERS_DOC,
          nRF_DOC,
          rec.CURNAMES,
          recs.RESIDENT_SIGN,
          rec.BANKPRG,
          rec.BANKACCTYPES,
          substr(sTMP,1,40),
          null,
          nRECIEVE_TYPE,
          null,
          null,
          nRECIEVE_CARD,
          nINCOME,
          recs.JOBBEGIN_DATE,
          null,
          0,
          nSLREGOPACCPR
        );
      end if;
    end loop;

    update UDOT_SLREGOPACC
       set FORM_DATE = nvl(dFORM_DATE,P_TOOLS_NOW)
     where RN = nRN;
    if (SQL%NOTFOUND) then
      PKG_MSG.RECORD_NOT_FOUND( nRN,'UdotSalaryRegistersOpenAccounts' );
    end if;
    --    
    for rc in (
    select s.ident
      from selectlist s
     where s.authid = user
       and s.session_id = pkg_session.get_session_id
     group by s.ident
    ) loop
      p_selectlist_clear(rc.ident);
    end loop;
    /*     */
    PKG_ENV.EPILOGUE( nCOMPANY,null,rec.CRN,rec.JUR_PERS,null,'UdotSalaryRegistersOpenAccounts','UDOT_SLREGOPACC_FORM','UDOT_SLREGOPACC',nRN );
  end loop;
end P_UDOT_SLREGOPACC_FORMING;
/

grant execute on P_UDOT_SLREGOPACC_FORMING to public;

spool off

