
spool c:\BSPb\Parus8\Addon\logs\__create_table.log


--ACCEPT INDX CHAR PROMPT 'Enter tablespace for index: '

--BANK_SPB_PNFF_DBF
--BANK_SPB_ZCOMP_DBF
--BANK_SPB_BFF_NEW_DBF
--BANK_SPB_BFF_OLD_DBF
--UDOT_BANKNUMBFILES

alter table UNITFUNC_REF add DISABLE_DUP number(1);

-- Create table
create global temporary table BANK_SPB_PNFF_DBF
(
  FNAME    VARCHAR2(32) not null,
  LNAME    VARCHAR2(32) not null,
  SNAME    VARCHAR2(32),
  SEX      VARCHAR2(1) not null,
  BIRTHDAY DATE not null,
  PLACE_B  VARCHAR2(250) not null,
  COUNTRY  VARCHAR2(2),
  "INDEX"  NUMBER(6),
  AREA     VARCHAR2(40),
  PUNKT    VARCHAR2(40),
  CITY     VARCHAR2(35) default '-' not null,
  STREET   VARCHAR2(30) default '-' not null,
  HOUSE    VARCHAR2(7) default '-' not null,
  BLOCK    VARCHAR2(7) default '-' not null,
  APPART   VARCHAR2(7) default '-' not null,
  ADRESS   VARCHAR2(80) not null,
  PHONE    VARCHAR2(20) not null,
  PASNOM   VARCHAR2(20) not null,
  PASDAT   DATE not null,
  PASPLACE VARCHAR2(250) not null,
  MKART    VARCHAR2(100),
  PERMIS   VARCHAR2(100),
  COMPANY  NUMBER(15) not null,
  TABNOM   NUMBER(15),
  INDCOD   NUMBER(4)
)
on commit delete rows;
-- Add comments to the table 
comment on table BANK_SPB_PNFF_DBF
  is '     "  "   ';
-- Add comments to the columns 
comment on column BANK_SPB_PNFF_DBF.FNAME
  is '';
comment on column BANK_SPB_PNFF_DBF.LNAME
  is '';
comment on column BANK_SPB_PNFF_DBF.SNAME
  is '';
comment on column BANK_SPB_PNFF_DBF.SEX
  is ' (""  "")';
comment on column BANK_SPB_PNFF_DBF.BIRTHDAY
  is ' ';
comment on column BANK_SPB_PNFF_DBF.PLACE_B
  is '  (  ,   )';
comment on column BANK_SPB_PNFF_DBF.COUNTRY
  is '  (   ,  , )';
comment on column BANK_SPB_PNFF_DBF."INDEX"
  is '  ';
comment on column BANK_SPB_PNFF_DBF.AREA
  is '   (    PUNKT,   AREA    ,  ,  )';
comment on column BANK_SPB_PNFF_DBF.PUNKT
  is '    (,   ..) (    )';
comment on column BANK_SPB_PNFF_DBF.CITY
  is '  .   ,  <-> (  )';
comment on column BANK_SPB_PNFF_DBF.STREET
  is '  .   ,  <-> (  )';
comment on column BANK_SPB_PNFF_DBF.HOUSE
  is '   .   ,  <-> (  )';
comment on column BANK_SPB_PNFF_DBF.BLOCK
  is '  .   ,  <-> (  )';
comment on column BANK_SPB_PNFF_DBF.APPART
  is '   .   ,  <-> (  )';
comment on column BANK_SPB_PNFF_DBF.ADRESS
  is '   .   ,    .    .         ,   .';
comment on column BANK_SPB_PNFF_DBF.PHONE
  is ' .      .';
comment on column BANK_SPB_PNFF_DBF.PASNOM
  is '   .  -          ( ): SS SS NNNNNN,  -   (  )   .';
comment on column BANK_SPB_PNFF_DBF.PASDAT
  is '  ';
comment on column BANK_SPB_PNFF_DBF.PASPLACE
  is '  .   - <_ _", ';
comment on column BANK_SPB_PNFF_DBF.MKART
  is '  . (  ,   ,       )';
comment on column BANK_SPB_PNFF_DBF.PERMIS
  is ' ,             (,   ..) (  )';
comment on column BANK_SPB_PNFF_DBF.COMPANY
  is ' . ffFFXXXXX,  FFff -   , XXXXX -  ';
comment on column BANK_SPB_PNFF_DBF.TABNOM
  is ' ';
comment on column BANK_SPB_PNFF_DBF.INDCOD
  is '  ';


create global temporary table BANK_SPB_ZCOMP_DBF
(
  PAN     VARCHAR2(16) not null,
  FIO     VARCHAR2(40) not null,
  PASNOM  VARCHAR2(20) not null,
  ACCOUNT VARCHAR2(20) not null
)
on commit delete rows;
-- Add comments to the table 
comment on table BANK_SPB_ZCOMP_DBF
  is '     "     "   ';
-- Add comments to the columns 
comment on column BANK_SPB_ZCOMP_DBF.PAN
  is ' ';
comment on column BANK_SPB_ZCOMP_DBF.FIO
  is '     .    .';
comment on column BANK_SPB_ZCOMP_DBF.PASNOM
  is '    ';
comment on column BANK_SPB_ZCOMP_DBF.ACCOUNT
  is '  ';


create global temporary table BANK_SPB_BFF_NEW_DBF
(
  SBK_NUM    VARCHAR2(20) not null,
  SBK_SUM    NUMBER(15,2) not null,
  SBK_FIO    VARCHAR2(90) not null,
  SBK_PAS    VARCHAR2(20),
  COMPANY    NUMBER(15) not null,
  TABNOM     NUMBER(10),
  CONTRACTNO VARCHAR2(20),
  BIRTHDAY   DATE
)
on commit delete rows;
-- Add comments to the table 
comment on table BANK_SPB_BFF_NEW_DBF
  is '     "   "   ';
-- Add comments to the columns 
comment on column BANK_SPB_BFF_NEW_DBF.SBK_NUM
  is ' ';
comment on column BANK_SPB_BFF_NEW_DBF.SBK_SUM
  is '   ';
comment on column BANK_SPB_BFF_NEW_DBF.SBK_FIO
  is '       .   .';
comment on column BANK_SPB_BFF_NEW_DBF.SBK_PAS
  is '   ';
comment on column BANK_SPB_BFF_NEW_DBF.COMPANY
  is 'ffFFXXXXX,  FFff -    , XXXXX -  ';
comment on column BANK_SPB_BFF_NEW_DBF.TABNOM
  is ' ';
comment on column BANK_SPB_BFF_NEW_DBF.CONTRACTNO
  is ' ';
comment on column BANK_SPB_BFF_NEW_DBF.BIRTHDAY
  is ' ';


create global temporary table BANK_SPB_BFF_DBF
(
  SBK_NUM    VARCHAR2(20) not null,
  SBK_SUM    NUMBER(15,2) not null,
  SBK_FIO    VARCHAR2(96) not null,
  SBK_PAS    VARCHAR2(20),
  COMPANY    NUMBER(15) not null,
  TABNOM     NUMBER(10),
  EDUCATION  NUMBER(15),
  CONTRACTNO VARCHAR2(20),
  BIRTHDAY   DATE,
  CODE	     VARCHAR2(1),
  FZ229_SUM  NUMBER(15,2)
)
on commit delete rows;
-- Add comments to the table 
comment on table BANK_SPB_BFF_DBF
  is '     "   "       1.06.2020';
-- Add comments to the columns 
comment on column BANK_SPB_BFF_DBF.SBK_NUM
  is '  ';
comment on column BANK_SPB_BFF_DBF.SBK_SUM
  is '   ';
comment on column BANK_SPB_BFF_DBF.SBK_FIO
  is ' ';
comment on column BANK_SPB_BFF_DBF.SBK_PAS
  is '    ';
comment on column BANK_SPB_BFF_DBF.COMPANY
  is 'ffFFXXXXX,  FFff -    , XXXXX -  ';
comment on column BANK_SPB_BFF_DBF.TABNOM
  is '    (     )';
comment on column BANK_SPB_BFF_DBF.EDUCATION
  is ' ';
comment on column BANK_SPB_BFF_DBF.CONTRACTNO
  is ' ';
comment on column BANK_SPB_BFF_DBF.BIRTHDAY
  is ' ';
comment on column BANK_SPB_BFF_DBF.CODE
  is ' ';
comment on column BANK_SPB_BFF_DBF.FZ229_SUM
  is '   229 ';

create table UDOT_BANKNUMBFILES
(
  COMPANY     NUMBER(17) not null,
  TYPE_FILE   VARCHAR2(10) not null,
  DATE_CREATE DATE default trunc(sysdate) not null,
  NUMB        NUMBER(17) not null,
  BANKCODE    VARCHAR2(20) not null
);
-- Add comments to the table 
comment on table UDOT_BANKNUMBFILES
  is '        ';
-- Add comments to the columns 
comment on column UDOT_BANKNUMBFILES.COMPANY
  is '  ';
comment on column UDOT_BANKNUMBFILES.TYPE_FILE
  is '  (''Z'',''B'',''P'',''N'')';
comment on column UDOT_BANKNUMBFILES.DATE_CREATE
  is '  ';
comment on column UDOT_BANKNUMBFILES.NUMB
  is '   ';
comment on column UDOT_BANKNUMBFILES.BANKCODE
  is '       ';
-- Create/Recreate primary, unique and foreign key constraints 
alter table UDOT_BANKNUMBFILES
  add constraint C_UDOT_BANKNUMBFILES_UK unique (BANKCODE, TYPE_FILE, DATE_CREATE, COMPANY)
  using index 
  tablespace &INDX_B1709
  pctfree 10
  initrans 2
  maxtrans 255
  storage
  (
    initial 128K
    next 1M
    minextents 1
    maxextents unlimited
  );
alter table UDOT_BANKNUMBFILES
  add constraint C_UDOT_BANKNUMBFILES_COMP_FK foreign key (COMPANY)
  references COMPANIES (RN);
-- Create/Recreate check constraints 
alter table UDOT_BANKNUMBFILES
  add constraint C_UDOT_BANKNUMBFILES_TYPE_VAL
  check (trim(TYPE_FILE) in ('Z','B','P','N'));

create or replace trigger T_UDOT_BANKNUMBFILES_BINSERT
  before insert on UDOT_BANKNUMBFILES for each row
begin
  /*     */
  :new.DATE_CREATE := trunc(:new.DATE_CREATE);
end T_UDOT_BANKNUMBFILES_BINSERT;
/


create or replace trigger T_UDOT_BANKNUMBFILES_BUPDATE
  before update on UDOT_BANKNUMBFILES for each row
begin
  /*     */
  :new.DATE_CREATE := trunc(:new.DATE_CREATE);
end T_UDOT_BANKNUMBFILES_BUPDATE;
/


spool off
